<?php

require_once("conf/conf.inc.php");

ini_set('session.use_only_cookies', 1);
ini_set('session.use_trans_sid', 0);
ini_set('session.name', 'TKSWIMSESSIONID');

date_default_timezone_set('Europe/Berlin');

if(TKSWIM_DEBUG){
	error_reporting(E_ALL & ~E_DEPRECATED);
	require_once(PFAD_INCLUDE.'func/printr.inc.php');
}
else{
	error_reporting(E_ALL & ~(E_NOTICE|E_DEPRECATED));
}

# Einstellungen, Klassen und Funktionen laden
require_once(PFAD_INCLUDE.'conf/select.inc.php');
require_once(PFAD_INCLUDE.'class/db.inc.php');
require_once(PFAD_INCLUDE.'class/tktemplate.inc.php');
require_once(PFAD_INCLUDE.'func/weiterleiten.inc.php');
require_once(PFAD_INCLUDE.'func/text_format.inc.php');
require_once(PFAD_INCLUDE.'func/prueferechte.inc.php');
require_once(PFAD_INCLUDE.'func/tkswim_fehlerbehandlung.inc.php');

# Konstante ROOT setzen
if(ROOT_HTTPS != '-' and ((strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST']) and isset($_SERVER['HTTPS'])) or isset($_SERVER['HTTP_X_FORWARDED_HOST']))){
	define('ROOT', ROOT_HTTPS);
	if(strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST'])){
		#$_SERVER['PHP_SELF'] = '/'.substr(ROOT_HTTP,7).$_SERVER['PHP_SELF'];
		ini_set('session.cookie_path', '/'.substr(ROOT_HTTP,7).'/');
	}
}
else{
	define('ROOT',ROOT_HTTP);
	if(ROOT != 'http://'.$_SERVER['HTTP_HOST']){
		ini_set('session.cookie_path', substr(ROOT_HTTP,strlen('http://'.$_SERVER['HTTP_HOST'])).'/');
	}
}

# Smarty starten und Variablen zuweisen
$_tmpl = new tktemplate;
$_tmpl->register_function('pruefeRechte','pruefeRechte');
$_tmpl->compile_check = TKSWIM_DEBUG;

# Fehlerbehandlung starten, Session starten
set_error_handler('tkswim_fehlerbehandlung');
session_start();

# Datenbankklasse starten und Verbindung oeffnen
$_inh = '';
$_db = new db;
$_db->tmpl = &$_tmpl;
$_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
if(TKSWIM_SCHREIBSCHUTZ){
	$_tmpl->assign('dauerhinweis','Achtung! tkswim ist gegen Schreibzugriffe geschützt, es können momentan keine Daten verändert werden!');
}
$_db->setzeDbParameter();
$_db->verbindeMitDb();

# globale Einstellungen laden
$_gleinst = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);

#unset($_SESSION['user']);

if(isset($_SESSION['eingelogt'])){

#printr($_SESSION);	
	
	
	# Einstellungen laden
	if(file_exists(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini')){
		$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_'.$_SESSION['user']['id'].'.ini',true);
	}
	else{
		$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini',true);
	}

	$_rauswerfen = array(
		'aktion' => false,
		'ausnahmen' => array(148)
	);

	# Zeitpunkt der letzten Aktivitaet speichern
	$timeout = TKSWIM_DEBUG?TKSWIM_TIMEOUT*300:TKSWIM_TIMEOUT;
	if((time() - $_SESSION['user']['letzterzugriff']) > $timeout){
		$vergangen = time() - $_SESSION['user']['letzterzugriff'];
		$_SESSION = array();
		if($vergangen <= ($timeout+21600)){
			# Meldung nur anzeigen wenn die letzte Aktion weniger als 6 Stunden+$timeout her ist
			$_SESSION['fehler'] = 'Die Sitzung ist abgelaufen, bitte neu anmelden.';
		}
		$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini',true);
	}
	elseif($_rauswerfen['aktion'] and !in_array($_SESSION['user']['id'],$_rauswerfen['ausnahmen'])){
		$_SESSION = array();
		$_SESSION['fehler'] = 'Wegen Wartungsarbeiten wurden alle Mitglieder abgemeldet.';
	}
	else{
		$_SESSION['user']['letzterzugriff'] = time();
	}
	if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
		$_GET['sicher'] = 1;
	}
}
elseif(!isset($_SESSION['user'])){
	$_SESSION['user'] = array(
		'letzterzugriff' => time(),
		'id' => false,
		'homeverzeichnis' => false,
		'realname' => ''
	);
	$_SESSION['eingelogt'] = 'auto';
	$_SESSION['flags'] = array('abzuwickelndewettkaempfe'=> false);
	$_SESSION['suche'] = array(
		'einst' => array('einstspeichern' => 1),
		'formular' => 'einfach'
	);
	# Rechte und Rechtegruppen des Users holen
	$query = "SELECT rechteid as id
				FROM ".DB_PREFIX."rechtegruppen_rechte
				WHERE rechtegrid = 8";
	$_db->holeDaten($query);
	$_SESSION['user']['rechte'] = $_db->baueArray('id','#');
	$_SESSION['user']['rechtegruppen'] = array(8);
	# userspezifische Einstellungen laden
	if(file_exists(PFAD_INIDATEIEN.'userconf_default.ini')){
		$_einst = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini', true);
	}
	# Darstellungsoptionen speichern
	$_SESSION['darstellung'] = array(
		'hintergrund' => file_exists(PFAD_HTTP.'src/img/hintergrund.png'),
		'favicon'     => file_exists(PFAD_HTTP.'src/img/favicon.ico')
	);
	# abzuwickelnde Wettkämpfe einlesen
	require_once(PFAD_INCLUDE.'func/wettkaempfe_leseabzuwickelndeein.inc.php');
	wettkaempfe_leseAbzuwickelndeEin();

}
#$_inh .= printr($_SESSION,1,1);
$_tmpl->assign('cssstyle',isset($_einst)?$_einst['globaleeinstellungen']['style']:'screen_navoben.css');
# EOF
?>