<?php

require_once(PFAD_INCLUDE.'class/zip.inc.php');
class ooodateien extends zipfile {

var $_tmpl;
var $datei;
var $inhalt;
var $einstellungen;

function ooodateien($_tmpl, $dateiart){
	# $_tmpl wird nicht per Referenz uebergeben, da der Template-Pfad in der Klasse gesetzt wird
	$this->tmpl = $_tmpl;
	$this->zipfile();

	$dateien = array(
		'startrechtwechsel' => array(
			'art'         => 'odt',
			'verzeichnis' => '003_startrechtwechsel'
		),
		'erstregistrierung' => array(
			'art'         => 'odt',
			'verzeichnis' => '006_erstregistrierung'
		),
		'meldebogen' => array(
			'art'         => 'odt',
			'verzeichnis' => '101_meldebogen'
		),
	);
	$module = parse_ini_file(PFAD_INCLUDE.'/conf/module.ini', true);
	if(isset($module['wkabwickeln']) and isset($module['wkabwickeln']['dmsj'])){
		$dateien['dmsjmeldebogen'] = array(
			'art'         => 'odt',
			'verzeichnis' => '106_dmsjmeldebogen'
		);
	}
	if(isset($module['wkabwickeln']) and isset($module['wkabwickeln']['dms'])){
		$dateien['dmsmeldebogen'] = array(
			'art'         => 'odt',
			'verzeichnis' => '105_dmsmeldebogen'
		);
	}

	$mimetypen = array(
		'odt' => 'application/vnd.oasis.opendocument.text',
		'ods' => 'application/vnd.oasis.opendocument.spreadsheet'
	);
	$this->datei = array(
		'dateiart'  => $dateiart,
		'verzeichnis' => $dateien[$dateiart]['verzeichnis'],
		'mimetype'  => $mimetypen[$dateien[$dateiart]['art']],
		'dateiname' => $dateiart.'.'.$dateien[$dateiart]['art']
	);
}


function speichereDateiImDateisystem(){
	# Dateien-Klasse aufrufen und Datei speichen
}

function setzeWerte($parameter,$wert){
	$this->tmpl->assign($parameter,$wert);
}

function setzeEinstellung($gruppe, $name, $type, $wert){
	if(!isset($this->einstellungen[$gruppe])){
		$this->einstellungen[$gruppe] = array();
	}
	$this->einstellungen[$gruppe][] = array(
		'name' => $name,
		'type' => $type,
		'wert' => $wert
	);
}

function setzeDateiname($dateiname){
	$this->datei['dateiname'] = $dateiname;
}

function generiereDateien(){
	$dateiinhalte = array(
		'startrechtwechsel' => array(
			'bilder' => array(
				'dsv-logo.png' => '10000201000000960000003A9E4E75E2.png'
			),
			'templates' => array(
				'meta.xml'    => 'meta.xml',
				'content.xml' => 'content.xml'
			),
			'dateien' => array(
				'manifest.xml' => 'META-INF/manifest.xml',
				'styles.xml'   => 'styles.xml'
			)
		),
		'erstregistrierung' => array(
			'bilder' => array(
				'dsv-logo.png' => '10000201000000960000003A9E4E75E2.png'
			),
			'templates' => array(
				'meta.xml'    => 'meta.xml',
				'content.xml' => 'content.xml'
			),
			'dateien' => array(
				'manifest.xml' => 'META-INF/manifest.xml',
				'styles.xml'   => 'styles.xml'
			)
		),
		'meldebogen' => array(
			'bilder' => array(
				'dsv-logo.png' => '10000201000000960000003A9E4E75E2.png'
			),
			'templates' => array(
				'meta.xml'    => 'meta.xml',
				'content.xml' => 'content.xml'
			),
			'dateien' => array(
				'manifest.xml' => 'META-INF/manifest.xml',
				'styles.xml'   => 'styles.xml'
			)
		),
		'dmsjmeldebogen' => array(
			'bilder' => array(
				'dsv-logo.png' => '10000201000000960000003A9E4E75E2.png'
			),
			'templates' => array(
				'meta.xml'    => 'meta.xml',
				'content.xml' => 'content.xml'
			),
			'dateien' => array(
				'manifest.xml' => 'META-INF/manifest.xml',
				'styles.xml'   => 'styles.xml'
			)
		),
		'dmsmeldebogen' => array(
			'bilder' => array(
				'dsv-logo.png' => '10000201000000960000003A9E4E75E2.png'
			),
			'templates' => array(
				'meta.xml'    => 'meta.xml',
				'content.xml' => 'content.xml'
			),
			'dateien' => array(
				'manifest.xml' => 'META-INF/manifest.xml',
				'styles.xml'   => 'styles.xml'
			)
		)
	);

	$this->addFile_daten($this->datei['mimetype'], 'mimetype');
	$dateien = $dateiinhalte[$this->datei['dateiart']];

	foreach($dateien['templates'] as $quelle => $ziel){
		$inh = $this->tmpl->fetch(PFAD_INCLUDE.'export/ooo-dateien/'.$this->datei['verzeichnis'].'/'.$quelle);
		$this->addFile_daten($inh, $ziel);
	}
	foreach($dateien['dateien'] as $quelle => $ziel){
		$daten = file_get_contents(PFAD_INCLUDE.'export/ooo-dateien/'.$this->datei['verzeichnis'].'/'.$quelle);
		if(substr($daten, 0, 2) == '{*'){
			$daten = trim(substr($daten, strpos($daten, '*}')+2));
		}
		$this->addFile_daten($daten, $ziel);
	}
	foreach($dateien['bilder'] as $quelle => $ziel){
		$this->addFile_pfad(PFAD_INCLUDE.'export/bilder/'.$quelle, 'Pictures/'.$ziel);
	}

	if(count($this->einstellungen)>0){
		$this->tmpl->assign('einstellungen',$this->einstellungen);
		$settings = $this->tmpl->fetch(PFAD_INCLUDE.'export/ooo-dateien/settings.xml');
		$this->addFile_daten($settings, 'settings.xml');
	}
}

function gebeOooDateiAus(){
	global $_db;
	$_db->speichereGeaenderteTabellen();
	$this->gebeDateiAus($this->datei['dateiname'], $this->datei['mimetype']);
}

} # Ende der Klasse, EOF
?>