<?php

### Einstellungen ##############################################################
$include_pfad = './__inc/';
### Einstellungen Ende #########################################################

$_seite = 'admin';
require_once($include_pfad.'conf/conf.inc.php');
if(TKSWIM_DEBUG){
	$startzeit = microtime(true);
	error_reporting(E_ALL & ~E_DEPRECATED);
	require_once(PFAD_INCLUDE.'func/printr.inc.php');
}
else{
	error_reporting(E_ALL & ~E_NOTICE & ~E_DEPRECATED);
}

# Einstellungen, Klassen und Funktionen laden
require_once($include_pfad.'class/db.inc.php');
require_once($include_pfad.'class/tktemplate.inc.php');
require_once($include_pfad.'func/weiterleiten.inc.php');
require_once($include_pfad.'func/text_format.inc.php');
require_once($include_pfad.'conf/select.inc.php');

function pruefeRechte(){
	$rechte = func_get_args();
	global $_seite;
	if($_seite == 'admin' and $rechte[0] != '_dummy'){
			return true;
	}
	return false;
}

# ROOT-Konstante setzen
if(ROOT_HTTP != ''){
	if((strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST']) and isset($_SERVER['HTTPS'])) or isset($_SERVER['HTTP_X_FORWARDED_HOST'])){
		define('ROOT', ROOT_HTTPS);
		if(strpos(ROOT_HTTPS, $_SERVER['HTTP_HOST'])){
			ini_set('session.cookie_path', '/'.substr(ROOT_HTTP,7).'/');
		}
	}
	else{
		define('ROOT',ROOT_HTTP);
		if(ROOT != 'http://'.$_SERVER['HTTP_HOST']){
			ini_set('session.cookie_path', substr(ROOT_HTTP,strlen('http://'.$_SERVER['HTTP_HOST'])).'/');
		}
	}
}
else{
	define('ROOT', htmlspecialchars('http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF'])));
}
ini_set('session.use_only_cookies', 1);
ini_set('session.use_trans_sid', 0);
ini_set('session.name', 'TKSWIMSESSIONID');
session_start();

# Smarty starten und Variablen zuweisen
$_tmpl = new tktemplate;
$_tmpl->register_function('pruefeRechte','pruefeRechte');
$_tmpl->register_function('strlen','strlen');
$_tmpl->tk_fussnoten = array();
if(!is_dir(PFAD_HTTP)){
	$_tmpl->template_dir  = $include_pfad.'templates/';
	$_tmpl->compile_dir   = $include_pfad.'templates_c/';
	$_tmpl->plugins_dir[] = $include_pfad.'templates/_plugins/';
}

if((!defined('TKSWIM_DATEIENDUNG') or !is_dir(PFAD_HTTP)) and !isset($_SESSION['adminlogin'])){
	if(isset($_POST['anmelden'])){
		if($_POST['loginanmeldename'] == 'admin' and $_POST['loginpasswort'] == TKSWIM_ADMINPASSWORT){
			$_SESSION['eingelogt'] = 1;
			$_SESSION['adminlogin'] = 1;
			$_SESSION['user']['name'] = 'admin';
			$_SESSION['user']['realname'] = 'admin';
			$_SESSION['user']['letzterzugriff'] = time();
			$_SESSION['user']['id'] = 0;
			if(isset($_SESSION['versuche'])){
				unset($_SESSION['versuche']);
			}
			unset($_SESSION['vonseite']);
			if(isset($_SESSION['fehler'])){
				unset($_SESSION['fehler']);
			}
			# und ab zur Adminseite
			weiterleiten('/admin.php');
		}
		else{
			if(!isset($_SESSION['versuche'])){
				$_SESSION['versuche'] = 1;
			}
			else{
				$_SESSION['versuche']++;
			}
			# warten und dann Fehlermeldung zuweisen
			if($_SESSION['versuche'] <= 2){
				sleep(0.2);
			}
			elseif($_SESSION['versuche'] <= 10){
				sleep(1);
			}
			else{
				sleep(10);
			}
			$_SESSION['fehler'] = 'falsche Daten';
		}
	}
	$_tmpl->assign('cssstyle','screen_navoben.css');
	$_inh = $_tmpl->fetch('admin/29.index.inc.html');
	# Loginformular
	if(!isset($_SESSION['eingelogt']) or $_SESSION['eingelogt']=='auto'){
		$login = '';
		$login .= '<form action="'.ROOT.'/admin.php" method="post" class="anmeldeform">';
		$login .= '<fieldset><legend>Login</legend>';
		if(!empty($_SESSION['fehler'])){
			$login .= '<p class="fehler">'.$_SESSION['fehler'].'</p>';
		}
		$login .= '<p>';
		$v = isset($_POST['loginanmeldename'])?text_format($_POST['loginanmeldename'],'value'):'';
		$login .= '<label>Benutzername: <input type="text" size="15" name="loginanmeldename"'.$v.' /></label><br />';
		$login .= '<label>Passwort: <input type="password" size="15" name="loginpasswort" /></label><br />';
		$login .= '<input type="hidden" name="anmelden" value="1" />';
		$login .= '<input type="submit" value="Anmelden" />';
		$login .= '</p><p>';
		if(ROOT_HTTPS != '-'){
			$https = (ROOT_HTTP==ROOT);
			$login .= '<a href="'.($https?ROOT_HTTPS:ROOT_HTTP).'/admin.php" title="über eine verschlüsselte Verbindung auf tkswim zugreifen">HTTP'.($https?'S':'').'&nbsp;verwenden</a> ';
		}
		$login .= '</p></fieldset></form>';
		$_inh = $login.$_inh;
	}
	$_tmpl->assign('inhalt',$_inh);
	$_tmpl->assign('s',$_seite);
	$inhalt = $_tmpl->fetch('tmpl.inc.html');
	if(!headers_sent()){
		header('x-Powered-By: tkswim');
	}
	echo $inhalt;
	exit;
}

# Datenbankklasse starten und Verbindung oeffnen
$_inh = '';
if(DB_BENUTZERNAME != ''){
	$_db = new db;
	$_db->tmpl = &$_tmpl;
	$_db->schreibschutz = TKSWIM_SCHREIBSCHUTZ;
	if(TKSWIM_SCHREIBSCHUTZ){
		$_tmpl->assign('dauerhinweis','Achtung! Die Datenbank ist gegen Schreibzugriffen geschützt, es können momentan keine Daten verändert werden!');
	}
	$_db->setzeDbParameter();
	$_db->verbindeMitDb();
}
else{
	$_db = false;
}

if(!isset($_SESSION['adminlogin']) and is_dir(PFAD_HTTP)){
	weiterleiten('/');
}

if(isset($_SESSION['eingelogt'])){
	# Einstellungen laden
	$_einst = parse_ini_file($include_pfad.'ini_speicher/userconf_default.ini',true);

	# Zeitpunkt der letzten Aktivitaet speichern
	if((time() - $_SESSION['user']['letzterzugriff']) > TKSWIM_TIMEOUT){
		$_SESSION = array();
		$_SESSION['fehler'] = 'Die Sitzung ist abgelaufen, bitte neu anmelden.';
	}
	else{
		$_SESSION['user']['letzterzugriff'] = time();
	}
	if($_einst['globaleeinstellungen']['sicherheitsabfragenabschalten']){
		$_GET['sicher'] = 1;
	}
}
$_tmpl->assign('cssstyle','screen_navoben.css');

$_tmpl->assign('ueberschrift','Administration von tkswim');
if(!isset($_SESSION['adminlogin'])){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'verwaistedateien':
	function leseEbene($pfad, $dateien){
		$dh = opendir($pfad);
		if($dh===false){
			return false;
		}
	    while (false !== ($file = readdir($dh))){
	    	if($file=='.' or $file=='..' or $file == '___release'){
	    		continue;
	    	}
	    	if(is_dir($pfad.$file)){
	    		$dateien = leseEbene($pfad.$file.'/', $dateien);
	    	}
	    	else{
	        	$dateien[] = $pfad.$file;
	        }
	    }
	    closedir($dh);
	    return $dateien;
	}

	$laenge = strlen(PFAD_HTTP);

	$verwaistedateien = array();
	# installierte Dateien holen
	require_once(PFAD_INCLUDE.'code/admin.dateien.inc.php');
	# installierte Dateien um die Dateien der Module ergänzen
	$module = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
	foreach($module['_versionen'] as $modul => $version){
		$modulconf = parse_ini_file(PFAD_INCLUDE.'module/'.$modul.'/conf.ini', true);
		foreach($modulconf['dateien'] as $datei){
			$installiertedateien[] = $datei;
		}
	}
	# Sonderdateien die vorhanden sein können noch hinzufügen
	$installiertedateien[] = 'src/img/favicon.ico';
	$installiertedateien[] = 'src/img/_hintergrund.png';
	$installiertedateien[] = '__inc/export/bilder/trainerabrechnung_logo.png';
	$installiertedateien[] = '__inc/export/bilder/meldezettel_logo.png';
	# zu ignorierende Dateien den installierten hinzufügen
	foreach($ignorieren['dateien'] as $i){
		$dat = glob($i);
		if(!is_array($dat)){
			continue;
		}
		foreach($dat as $d){
			$installiertedateien[] = substr($d, $laenge);
		}
	}
	# Dateien aus den zu ignorierenden Pfaden den installierten hinzufügen
	foreach($ignorieren['pfade'] as $i){
		$pfad = leseEbene($i, array());
		foreach($pfad as $p){
			$installiertedateien[] = substr($p, $laenge);
		}
	}

	# vorhandene Dateien holen
	$vorhandenedateien = leseEbene(PFAD_HTTP, array());
	foreach($vorhandenedateien as $key => $datei){
		$datei = substr($datei, $laenge);
		if(in_array($datei, $installiertedateien)){
			continue;
		}
		if(in_array($datei, $installiertedateien)){
			continue;
		}
		$verwaistedateien[] = $datei;
	}
	$_inh .= '<h2>verwaiste Dateien</h2>';
	if(count($verwaistedateien) == 0){
		$_inh .= '<p>Es wurden keine verwaisten Dateien gefunden.';
	}
	else{
		$anz = count($verwaistedateien);
		if($anz == 1){
			$_inh .= 'Es wurde eine verwaiste Datei gefunden. Sie kann gelöscht werden, da sie für den Betrieb von tkswim nicht nötig ist.</p>';
		}
		else{
			$_inh .= 'Es wurden '.$anz.' verwaiste Dateien gefunden. Sie können gelöscht werden, da sie für den Betrieb von tkswim nicht nötig sind.</p>';
		}
		$_inh .= '<ul>';
		foreach($verwaistedateien as $datei){
			$_inh .= '<li>'.$datei.'</li>';
		}
	}
	break;

case 'module':
	$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
	$_bereiche = array(
		'wkabwickeln' => 'Wettkampfabwicklung',
		'sonstiges'   => 'Sonstiges',
		'code'        => 'Code'
	);

	if(isset($_GET['details']) and in_array($_GET['details'], array_keys($vorhandenemodule['_versionen']))){
		$daten = parse_ini_file(PFAD_INCLUDE.'module/'.$_GET['details'].'/conf.ini', true);
		$daten['conf']['bereich'] = $_bereiche[$daten['conf']['bereich']];
		foreach($daten['dateien'] as $key => $datei){
			$daten['dateien'][$key] = $datei;
		}
		foreach($daten['rechte'] as $key => $recht){
			$recht = substr($recht, strpos($recht,';')+1);
			$daten['rechte'][$key] = $recht;
		}
		$daten['conf']['tkswimversion'] = $daten['conf']['tkswimversion_bis']=='*'?'ab Version '.$daten['conf']['tkswimversion_ab']:'Versionen '.$daten['conf']['tkswimversion_ab'].' bis '.$daten['conf']['tkswimversion_bis'];

		$_tmpl->assign('daten', $daten);
		$_inh .= $_tmpl->fetch('admin/29.admin-module-details.inc.html');
	}
	elseif(isset($_GET['installieren'])){
		if(!isset($_SESSION['installieren'])){
			# noch nicht installierte Module suchen
			$installierte = array_keys($vorhandenemodule['_versionen']);
			$pfad = PFAD_INCLUDE.'module/';
			$dh = opendir($pfad);
			if($dh === false){
				trigger_error('Das Modulverzeichnis kann nicht geöffnet werden.', E_USER_ERROR);
			}
			$zuinstallierende = array();
			while(($file = readdir($dh)) !== false){
				if(!is_dir($pfad.$file) or $file == '.' or $file == '..'){
					continue;
				}
				if(in_array($file, $installierte)){
					# das Modul in diesem Verzeichnis ist bereits installiert
					continue;
				}
				if(!file_exists($pfad.$file.'/conf.ini')){
					# im Modulverzeichnis existiert keine conf.ini
					continue;
				}
				$conf = parse_ini_file($pfad.$file.'/conf.ini', true);
				if(version_compare($conf['conf']['tkswimversion_ab'], TKSWIM_VERSION, '>')){
					# die eingesetzte tkswim-Version ist zu alt für das Modul
					continue;
				}
				if($conf['conf']['tkswimversion_bis'] != '*' and version_compare(str_replace('*','99',$conf['conf']['tkswimversion_bis']), TKSWIM_VERSION, '<')){
					# die eingesetzte tkswim-Version ist zu jung für das Modul
					#  (das Modul kann also nur mit einer früheren Version von tkswim eingesetzt werden)
					continue;
				}
				$zuinstallierende[$file] = $conf['conf']['name'].' ('.$_bereiche[$conf['conf']['bereich']].', Version '.$conf['conf']['version'].')';
			}
			closedir($dh);
			if(isset($_POST['modul']) and in_array($_POST['modul'], array_keys($zuinstallierende))){
				$_SESSION['installieren'] = $_POST['modul'];
				weiterleiten('/admin.php?aktion=module&installieren');
			}
			$_tmpl->assign('zuinstallierende', $zuinstallierende);
			$_inh .= $_tmpl->fetch('admin/29.admin-module-installieren-waehlen.inc.html');
		}
		else{
			# Moduldaten holen
			$moduldat = parse_ini_file(PFAD_INCLUDE.'module/'.$_SESSION['installieren'].'/conf.ini', true);
			# noch fehlende Dateien sammeln
			$fehlendedateien = array();
			foreach($moduldat['dateien'] as $datei){
				$datei = PFAD_HTTP.$datei;
				if(file_exists($datei)){
					continue;
				}
				$fehlendedateien[] = $datei;
			}

			if(count($fehlendedateien) > 0){
				$_tmpl->assign('fehlendedateien', $fehlendedateien);
				$_inh .= $_tmpl->fetch('admin/29.admin-module-installieren-dateien.inc.html');
			}
			else{
				# Modul fertig anlegen
				# Tabellen anlegen
				if(isset($moduldat['conf']['datenbank'])){
					#$conf = parse_ini_file($pfad.$file.'/conf.ini', true);
					require_once(PFAD_INCLUDE.'module/'.$_SESSION['installieren'].'/datenbank.inc.php');
					$query = "SELECT TABLE_NAME FROM information_schema.TABLES WHERE TABLE_SCHEMA='".DB_NAME."'";
					$_db->holeDaten($query);
					$vorhandene = $_db->baueArray('TABLE_NAME','#');
					list($gruppe, $modul) = explode('_', $_SESSION['installieren']);
					foreach($datenbank[$gruppe][$modul]['tabellen'] as $tabelle => $query){
						if(in_array(DB_PREFIX.$tabelle, $vorhandene)){
							continue;
						}
						$_db->fuehreQueryAus($query);
					}
				}
				# Rechte anlegen
				if(count($moduldat['rechte'])>0){
					$rgr = $r = array();
					foreach($moduldat['rechte'] as $rid => $recht){
						list($sort, $bez) = explode(';', $recht, 2);
						$r[] = "('".text_format($rid,'db')."', '".text_format($sort,'db')."', '".text_format($bez,'db')."')";
						$rgr[] = "(1, '".text_format($rid,'db')."')";
					}
					$query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ', $r)."";
					$_db->fuehreQueryAus($query);
					$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ', $rgr)."";
					$_db->fuehreQueryAus($query);
				}
				# Eintrag in die modul.ini schreiben
				$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
				if(!isset($vorhandenemodule[$moduldat['conf']['bereich']])){
					$vorhandenemodule[$moduldat['conf']['bereich']] = array();
				}
				$vorhandenemodule[$moduldat['conf']['bereich']][substr($_SESSION['installieren'],strpos($_SESSION['installieren'], '_')+1)] = $moduldat['conf']['name'];
				$vorhandenemodule['_versionen'][$_SESSION['installieren']] = $moduldat['conf']['version'];
				require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
				schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $vorhandenemodule, true);
				# Sessiondaten löschen, weiterleiten
				unset($_SESSION['installieren']);
				weiterleiten('/admin.php?aktion=module','Das Modul wurde installiert.');
			}
		}
	}
	elseif(isset($_GET['deinstallieren']) and in_array($_GET['deinstallieren'], array_keys($vorhandenemodule['_versionen']))){
		if(isset($_SESSION['deinstallieren']) and $_SESSION['deinstallieren']['key'] != $_GET['deinstallieren']){
			unset($_SESSION['deinstallieren']);
		}

		if(!isset($_SESSION['deinstallieren']) and substr($_GET['deinstallieren'],0,11)=='wkabwickeln'){
			# prüfen ob Wettkämpfe mit dem zu löschenden Typ existieren
			$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften
						WHERE art = 'w' AND eigenschaft = 'wettkampfart' AND wert = '".substr($_GET['deinstallieren'],12)."'";
			$_db->holeDaten($query);
			if($_db->holeAnzahl() > 0){
				$_tmpl->assign('fehler', 'Das Modul kann nicht gelöscht werden, da Wettkämpfe mit diesem Wettkampftyp existieren.');
				$_inh .= '<p><a href="'.ROOT.'/admin.php?aktion=module">zurück zur Modulübersicht</a></p>';
				break;
			}
		}
		
		if(!isset($_SESSION['deinstallieren']) or $_SESSION['deinstallieren']['key'] != $_GET['deinstallieren']){
			# zum Löschen nötige Informationen in der Session speichern
			$speichern = array();
			$speichern['key'] = $_GET['deinstallieren'];
			$daten = parse_ini_file(PFAD_INCLUDE.'module/'.$_GET['deinstallieren'].'/conf.ini', true);
			$speichern['name'] = $daten['conf']['name'].' ('.$_bereiche[$daten['conf']['bereich']].')';
			$speichern['bereich'] = $daten['conf']['bereich'];
			# Dateilisten der anderen Module holen
			foreach($vorhandenemodule['_versionen'] as $key => $version){
				if($key == $_GET['deinstallieren']){
					continue;
				}
				$dat = parse_ini_file(PFAD_INCLUDE.'module/'.$key.'/conf.ini', true);
				foreach($dat['dateien'] as $datei){
					#$datei = PFAD_HTTP.$datei;
					$zubehaltendedateien[] = $datei;
				}
			}
			$zubehaltendedateien = array_unique($zubehaltendedateien);
			# zu löschende Dateien ermitteln
			$speichern['dateien'] = array();
			$speichern['zuloeschendedateien'] = 0;
			$speichern['modulverzeichnis'] = '';
			foreach($daten['dateien'] as $datei){

				if(in_array($datei, $zubehaltendedateien)){
					continue;
				}
				$speichern['dateien'][] = array(
					'datei' => $datei,
					'geloescht' => 0
				);
				if(substr($datei, -8) == 'conf.ini'){

					$speichern['modulverzeichnis'] = substr($datei, 0, -8);
				}
				$speichern['zuloeschendedateien']++;
			}
			$speichern['rechte'] = array();
			foreach($daten['rechte'] as $rid => $bezeichnung){
				$speichern['rechte'][] = $rid;
			}
			$_SESSION['deinstallieren'] = $speichern;
		}

		if(($_SESSION['deinstallieren']['zuloeschendedateien'] > 0 or !empty($_SESSION['deinstallieren']['modulverzeichnis'])) and isset($_POST['weiter'])){
			if(!empty($_SESSION['deinstallieren']['modulverzeichnis']) and !file_exists($_SESSION['deinstallieren']['modulverzeichnis'])){
				$_SESSION['deinstallieren']['modulverzeichnis'] = '';
			}
			foreach($_SESSION['deinstallieren']['dateien'] as $key => $datei){
				if($datei['geloescht'] == 1){
					continue;
				}
				if(!file_exists($datei['datei'])){
					$_SESSION['deinstallieren']['dateien'][$key]['geloescht'] = 1;
					$_SESSION['deinstallieren']['zuloeschendedateien']--;
				}
			}
		}

		$_tmpl->assign('modulname', $_SESSION['deinstallieren']['name']);
		if($_SESSION['deinstallieren']['zuloeschendedateien'] > 0 or !empty($_SESSION['deinstallieren']['modulverzeichnis'])){
			# es müssen noch Dateien gelöscht werden
			$_tmpl->assign('dateien', $_SESSION['deinstallieren']['dateien']);
			$_tmpl->assign('modulverzeichnis', $_SESSION['deinstallieren']['modulverzeichnis']);
			$_inh .= $_tmpl->fetch('admin/29.admin-module-loeschen-dateien.inc.html');
		}
		else{
			# restliches Zeug löschen
			# Rechte löschen
			if(count($_SESSION['deinstallieren']['rechte'])>0){
				$ids = "'".implode("','", $_SESSION['deinstallieren']['rechte'])."'";
				$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_rechte WHERE rechteid IN (".$ids.")";
				$_db->fuehreQueryAus($query);
				$query = "DELETE FROM ".DB_PREFIX."rechte WHERE id IN (".$ids.")";
				$_db->fuehreQueryAus($query);
			}
			# Einträge aus der modul.ini löschen
			$vorhandenemodule = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
			unset($vorhandenemodule['_versionen'][$_SESSION['deinstallieren']['key']]);
			$id = substr($_SESSION['deinstallieren']['key'], strpos($_SESSION['deinstallieren']['key'], '_')+1);
			unset($vorhandenemodule[$_SESSION['deinstallieren']['bereich']][$id]);
			if(count($vorhandenemodule[$_SESSION['deinstallieren']['bereich']]) < 1){
				unset($vorhandenemodule[$_SESSION['deinstallieren']['bereich']]);
			}
			# Reste in der Session entfernen
			unset($_SESSION['deinstallieren']);
			# ini-Datei schreiben und zurück zur Übersicht
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $vorhandenemodule, true);
			weiterleiten('/admin.php?aktion=module','Das Modul wurde gelöscht.');
		}
	}
	else{
		$module = array();
		foreach($vorhandenemodule['_versionen'] as $key => $version){
			list($b, $e) = explode('_', $key);
			$module[$key] = array(
				'bereich' => $_bereiche[$b],
				'bezeichnung' => $vorhandenemodule[$b][$e],
				'version' => $version
			);
		}
		ksort($module);
		$_tmpl->assign('module', $module);
		$_inh .= $_tmpl->fetch('admin/29.admin-module-index.inc.html');
	}
	break;

case 'backuperstellen':
	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
	$_db->holeDaten($query, E_USER_ERROR, 'row');
	$tabellen = $_db->baueArray('0','#');
	ini_set('memory_limit', '32M');
	$inhalt = $_db->exportiereDatenbank('',$tabellen);
	$dateiname = date('Y-m-d_H-i').'_tkswim.sql';
	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($inhalt, $dateiname, time());
	$zip->gebeDateiAus($dateiname.'.zip');
	exit;

case 'pfade':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	if(isset($_POST['speichern'])){
		require_once($include_pfad.'func/pruefen.inc.php');
		$f = '';
		$d = &$_POST['daten'];

		# HTTP-Verzeichnis
		if(!is_dir($_POST['daten']['pfad_http'])){
			$f .= 'Der Pfad zum obersten Verzeichnis von tkswim ist ungültig (das Verzeichnis existiert nicht)<br />';
		}
		elseif(substr($_POST['daten']['pfad_http'],-1) != '/'){
			$f .= 'Der Pfad zum obersten Verzeichnis von tkswim muss mit einem Slash (»/«) enden<br />';
		}
		# Smarty-Pfad
		if(!is_dir($_POST['daten']['pfad_smarty'])){
			$f .= 'Der Pfad zu Smarty ist ungültig (das Verzeichnis existiert nicht)<br />';
		}
		elseif(substr($_POST['daten']['pfad_smarty'],-1) != '/' or substr($_POST['daten']['pfad_smarty'],0,1) != '/'){
			$f .= 'Der Pfad zu Smarty muss mit einem Slash (»/«) beginnen und enden<br />';
		}
		elseif(!file_exists($_POST['daten']['pfad_smarty'].'Smarty.class.php')){
			$f .= 'Der Pfad zu Smarty ist ungültig (Smarty wurde in dem angegebenen Verzeichnis nicht gefunden)<br />';
		}
		# TCPDF-Pfad
		if(!is_dir($_POST['daten']['pfad_tcpdf'])){
			$f .= 'Der Pfad zu TCPDF ist ungültig (das Verzeichnis existiert nicht)<br />';
		}
		elseif(substr($_POST['daten']['pfad_tcpdf'],-1) != '/' or substr($_POST['daten']['pfad_tcpdf'],0,1) != '/'){
			$f .= 'Der Pfad zu TCPDF muss mit einem Slash (»/«) beginnen und enden<br />';
		}
		elseif(!file_exists($_POST['daten']['pfad_tcpdf'].'tcpdf.php')){
			$f .= 'Der Pfad zu TCPDF ist ungültig (TCPDF wurde in dem angegebenen Verzeichnis nicht gefunden)<br />';
		}
		# Templatesc
		if(!@is_dir($_POST['daten']['pfad_templatesc'])){
			$f .= 'Der Pfad zum Templatecache ist ungültig (das Verzeichnis existiert nicht)<br />';
		}
		elseif(substr($_POST['daten']['pfad_templatesc'],-1) != '/'){
			$f .= 'Der Pfad zum Templatecache muss mit einem Slash (»/«) enden<br />';
		}

		# HTTP-ROOT
		if(substr($_POST['daten']['root_http'],0,7) != 'http://'){
			$f .= 'Die HTTP-Domain muss mit http:// beginnen<br />';
		}
		if(substr($_POST['daten']['root_http'],-1) == '/'){
			$f .= 'Die HTTP-Domain darf nicht mit einem Slash (»/«) enden<br />';
		}
		# HTTPS-ROOT
		if($_POST['daten']['root_https'] != '-'){
			if(substr($_POST['daten']['root_https'],0,8) != 'https://'){
				$f .= 'Die HTTPS-Domain muss mit https:// beginnen<br />';
			}
			if(substr($_POST['daten']['root_https'],-1) == '/'){
				$f .= 'Die HTTPS-Domain darf nicht mit einem Slash (»/«) enden<br />';
			}
		}

		if(empty($f)){
			$speichern = array(
				'pfad_smarty'      => $d['pfad_smarty'],
				'pfad_tcpdf'       => $d['pfad_tcpdf'],
				'pfad_templatesc'  => $d['pfad_templatesc'],
				'pfad_http'        => $d['pfad_http'],
				'root_http'        => $d['root_http'],
				'root_https'       => $d['root_https']
			);
			$_tmpl->assign('daten',$speichern);
			$confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
			$fh = fopen($include_pfad.'conf/conf.inc.php','w');
			fwrite($fh, $confinhalt, strlen($confinhalt));
			fclose($fh);
			weiterleiten('/admin.php','Die Änderungen wurden gespeichert.');
		}
		else{
			$_tmpl->assign('fehler',$f);
			$daten = $_POST['daten'];
		}
	}
	else{
		$daten = array(
			'pfad_smarty'     => (PFAD_SMARTY==''?(isset($_SESSION['_smarty'])?substr($_SESSION['_smarty'],-16):''):PFAD_SMARTY),
			'pfad_tcpdf'      => ((PFAD_TCPDF=='' and file_exists(PFAD_INCLUDE.'class/tcpdf/tcpdf.php'))?PFAD_INCLUDE.'class/tcpdf/':PFAD_TCPDF),
			'pfad_templatesc' => PFAD_TEMPLATESC,
			'pfad_http'       => PFAD_HTTP,
			'root_http'       => ROOT_HTTP,
			'root_https'      => ROOT_HTTPS
		);
	}
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-pfade.inc.html');
	break;

case 'rechteueberpruefen':
	$verzeichnisse = array(
		PFAD_INCLUDE.'bilder_speicher/',
		PFAD_DATEIEN,
		PFAD_INIDATEIEN,
		PFAD_INCLUDE.'sicherung/',
		PFAD_INCLUDE.'export/pdf_fonts/',
		PFAD_TMP,
		PFAD_TEMPLATESC
	);
	$dateien = array(
		PFAD_HTTP.'.htaccess',
		PFAD_LOGDATEIEN.'cronjob.ini',
		PFAD_LOGDATEIEN.'dbaenderungen.ini',
		PFAD_LOGDATEIEN.'logdatei.log',
		PFAD_INCLUDE.'conf/cronjob.ini',
		PFAD_INCLUDE.'conf/conf.inc.php',
		PFAD_INCLUDE.'conf/einstellungen.ini',
		PFAD_INCLUDE.'conf/emails.ini',
		PFAD_INCLUDE.'conf/module.ini',
		PFAD_INIDATEIEN.'dateien_tmp.ini',
		PFAD_INIDATEIEN.'userconf_default.ini',
		PFAD_INIDATEIEN.'zeiten_export.ini',
		PFAD_DATEIEN.'anwenderhandbuch.pdf'
	);
	$daten = array('v'=>array(),'d'=>array());
	foreach($verzeichnisse as $verz){
		$daten['v'][$verz] = is_writable($verz);
	}
	foreach($dateien as $dat){
		$daten['d'][$dat] = is_writable($dat);
	}
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-rechteueberpruefen.inc.html');
	break;

case 'sonstige':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	$_lsvkennziffern = array(
		'01' => '01 - Badischer Schwimm-Verband',
		'02' => '02 - Bayerischer Schwimm-Verband',
		'03' => '03 - Berliner Schwimm-Verband',
		'04' => '04 - Landesschwimmverband Brandenburg',
		'05' => '05 - Landesschwimmverband Bremen',
		'06' => '06 - Hamburger Schwimm-Verband',
		'07' => '07 - Hessischer Schwimm-Verband',
		'08' => '08 - Schwimmverband Mecklenburg/Vorpommern',
		'09' => '09 - Landesschwimmverband Niedersachsen',
		'10' => '10 - Schwimmverband Rheinland',
		'11' => '11 - Saarländischer Schwimm-Bund',
		'12' => '12 - Sächsischer Schwimm-Verband',
		'13' => '13 - Landesschwimmverband Sachsen-Anhalt',
		'14' => '14 - Schleswig-Holsteinischer Schwimm-Verband',
		'15' => '15 - Südwestdeutscher Schwimm-Verband',
		'16' => '16 - Thüringer Schwimm-Verband',
		'17' => '17 - Schwimmverband Nordrhein-Westfalen',
		'18' => '18 - Schwimmverband Württemberg'
	);
	$_vereinsarten = array(
		'abteilung' => 'Abteilung',
		'verein'    => 'Schwimmverein',
		'sg'        => 'Startgemeinschaft (SG)'
	);
	$_dateiendungen = array(
		'.php'  => '.php (Standard)',
		'.html' => '.html',
		'.pl'   => '.pl',
		''      => '[keine]'
	);
	$dateigroesseaenderbar = true;
	if(substr(PHP_SAPI, 0, 3) == 'cgi'){
		$dateigroesseaenderbar = false;
	}
	/*
	Dateiendungen nur änderbar bzw. Kurzlinks aktivierbar wenn per
	  function testModRewrite() {
    if (function_exists('apache_get_modules')) {
      $extensions = apache_get_modules();
      if (in_array('mod_rewrite', $extensions)) {
        return TESTRESULT_OK;
      } else {
        return TESTRESULT_FAILED;
      }
    }
    return TESTRESULT_UNKNOWN;
  }
   ermittelt wurde, dass mod_rewrite aktiviert ist.
	*/



	if(isset($_POST['speichern'])){
		require_once($include_pfad.'func/pruefen.inc.php');
		$f = '';
		$d = &$_POST['daten'];
		# Verein
		$f .= pruefen($d['verein'],'leer','Der Verein fehlt');
		$f .= pruefen($d['verein'],'maxlaenge','Der Verein ist zu lang (max. 200 Zeichen)',200);
		$f .= pruefen($d['vereinsart'],'wertemenge','Die Vereinsart ist ungültig',array_keys($_vereinsarten));
		$f .= pruefen($d['vereinsid'],'leer','Die Vereinsid fehlt');
		$f .= pruefen($d['vereinsid'],'regexpr','Die Vereinsid ist ungültig (sie muss aus genau 4 Ziffern bestehen)','^[0-9]{4}$');
		$f .= pruefen($d['lsvkennziffer'],'leer','Die LSV-Kennziffer fehlt');
		$f .= pruefen($d['lsvkennziffer'],'wertemenge','Die LSV-Kennziffer ist ungültig',array_keys($_lsvkennziffern));
		# tkswim
		$f .= pruefen($d['version'],'leer','Die Version fehlt');
		$f .= pruefen($d['version'],'maxlaenge','Die Version ist zu lang (max. 20 Zeichen)',20);
		# URL-Darstellung
		$f .= pruefen($d['dateiendung'],'wertemenge','Die Dateiendung ist ungültig',array_keys($_dateiendungen));
		# Dateiverwaltung
		$d['maxdateigroesse'] = str_replace(',','.',$d['maxdateigroesse']);
		$tmp = pruefen($d['maxdateigroesse'],'zahl','die maximale Dateigröße ist ungültig');
		if(empty($tmp) and (int)$d['maxdateigroesse'] > 50){
			$tmp .= 'Die maximale Dateigröße ist zu groß (max. 50 MB)<br />';
		}
		if(empty($tmp) and !$dateigroesseaenderbar){
			$maxwert = (int)min(ini_get('upload_max_filesize'), ini_get('post_max_size'));
			if($d['maxdateigroesse'] > $maxwert){
				$tmp .= 'Die maximale Dateigröße kann nicht auf '.(int)$d['maxdateigroesse'].'MB gesetzt werden, da PHP-Einstellungen den Upload so großer Dateien verhindern würden (möglich sind maximal '.$maxwert.'MB)<br />';
			}
		}
		if(!empty($tmp)){
			$f .= $tmp;
		}
		# diverses
		$f .= pruefen($d['adminpasswort'],'leer','Das Adminpasswort fehlt');
		$f .= pruefen($d['adminpasswort'],'passwort','Das Passwort muss aus mindestens je eines der
					Zeichen [a-zöäüß], [A-ZÖÄÜ] und [0-9] enthalten und mindestens 8 Zeichen lang sein.');
		$f .= pruefen($d['adminpasswort'],'maxlaenge','Das Adminpasswort ist zu lang (max. 200 Zeichen)',200);
		$tmp = pruefen($d['timeout'],'leer','Der Timeout-Wert fehlt');
		$tmp .= pruefen($d['timeout'],'zahl','Der Timeout ist keine Zahl');
		if(empty($tmp)){
			if($d['timeout']<2){
				$f .= 'Der Timeout-Wert ist zu klein (min. 2 Minuten)<br />';
			}
			if($d['timeout']>999){
				$f .= 'Der Timeout-Wert ist zu groß (max. 999 Minuten)<br />';
			}
		}
		else{
			$f .= $tmp;
		}

		if(empty($f)){
			# eigentlich wäre die oberen zwei Zeilen ideal, allerdings funktioniert das nicht, da bei der Prüfung
			#   der erhöhte Wert u.U. schon gesetzt ist, und der Eintrag damit weggelassen wird, obwohl er nötig wäre.
			#   eine Lösungsmöglichkeit wäre die Funktion ini_get_all() (mit zweitem Parameter, aber den gibt es erst ab PHP 5.3.0)
			#$grenze_umf = substr(ini_get('upload_max_filesize'),0,-1);
			#$grenze_pms = substr(ini_get('post_max_size'),0,-1);
			$grenze_umf = 2;
			$grenze_pms = 8;
			$speichern = array(
				'tkswim_verein'          => $d['verein'],
				'tkswim_vereinsart'      => $d['vereinsart'],
				'tkswim_vereinsid'       => $d['vereinsid'],
				'tkswim_lsvkennziffer'   => $d['lsvkennziffer'],
				'tkswim_version'         => $d['version'],
				'tkswim_dateiendung'     => $d['dateiendung'],
				'tkswim_kurzlinks'       => isset($d['kurzlinks'])?'true':'false',
				'tkswim_maxdateigroesse' => round($d['maxdateigroesse']*(1024*1024)),
				'tkswim_schreibschutz'   => isset($d['schreibschutz'])?'true':'false',
				'tkswim_adminpasswort'   => $d['adminpasswort'],
				'tkswim_timeout'         => $d['timeout']*60,
				'tkswim_debug'           => isset($d['debug'])?'true':'false',
				'upload_max_filesize' => ($d['maxdateigroesse']>$grenze_umf?$d['maxdateigroesse'].'M':false),
				'post_max_size'       => ($d['maxdateigroesse']>$grenze_pms?$d['maxdateigroesse'].'M':false)
			);

			$_tmpl->assign('daten',$speichern);
			$htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
			$fh = fopen(PFAD_HTTP.'.htaccess','w');
			fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
			fclose($fh);
			$confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
			$fh = fopen($include_pfad.'conf/conf.inc.php','w');
			fwrite($fh, $confinhalt, strlen($confinhalt));
			fclose($fh);
			weiterleiten('/admin.php','Die Änderungen wurden gespeichert.');
		}
		else{
			$_tmpl->assign('fehler',$f);
			$daten = $_POST['daten'];
		}
	}
	else{
		$daten = array(
			'verein'          => TKSWIM_VEREIN,
			'vereinsart'      => TKSWIM_VEREINSART,
			'vereinsid'       => TKSWIM_VEREINSID,
			'lsvkennziffer'   => TKSWIM_LSVKENNZIFFER,
			'version'         => TKSWIM_VERSION,
			'dateiendung'     => TKSWIM_DATEIENDUNG,
			'kurzlinks'       => TKSWIM_KURZLINKS?1:0,
			'maxdateigroesse' => round(TKSWIM_MAXDATEIGROESSE/(1024*1024),1),
			'schreibschutz'   => TKSWIM_SCHREIBSCHUTZ?1:0,
			'adminpasswort'   => TKSWIM_ADMINPASSWORT,
			'timeout'         => TKSWIM_TIMEOUT/60,
			'debug'           => TKSWIM_DEBUG?1:0
		);
	}
	$_tmpl->assign('_lsvkennziffern',$_lsvkennziffern);
	$_tmpl->assign('_vereinsarten',$_vereinsarten);
	$_tmpl->assign('_dateiendungen',$_dateiendungen);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery');
	$_tmpl->tk_javascriptzuweisen('onready',"\$('#adminpasswort').css('color','#FFF');");
	$_tmpl->tk_javascriptzuweisen('onready',"\$('#passwortzeigen').click(function(){
    \$('#adminpasswort').css('color','#000');
    \$(this).hide();
    return false;
  });");
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-sonstige.inc.html');
	break;

case 'zusicherndetabellen':
	if(!is_writable($include_pfad.'log/dbaenderungen.ini')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/log/dbaenderungen.ini) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
	$_db->holeDaten($query, E_USER_ERROR, 'row');
	$tabellen = $_db->baueArray('0','#');
	if(isset($_POST['speichern'])){
		$speichern = array();
		if(!isset($_POST['gespeicherte'])){
			$_POST['gespeicherte'] = array();
		}
		foreach($tabellen as $tabelle){
			if(!in_array($tabelle,$_POST['gespeicherte'])){
				continue;
			}
			$speichern[$tabelle] = 1;
		}
		require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
		schreibe_ini_datei($include_pfad.'log/dbaenderungen.ini',$speichern,false);
		weiterleiten('/admin.php','Die Tabellen wurden gespeichert');
	}
	else{
		$daten = array();
		$gespeichert = parse_ini_file($include_pfad.'log/dbaenderungen.ini',false);
		foreach($gespeichert as $tabelle => $sichern){
			if($sichern != 1){
				continue;
			}
			$daten[] = $tabelle;
		}
	}
	$_tmpl->assign('tabellen',$tabellen);
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-zusicherndetabellen.inc.html');
	break;

case 'email':
	if(!is_writable($include_pfad.'conf/emails.ini')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/emails.ini) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	$_dusie = array(
		'du'  => 'geduzt',
		'sie' => 'gesiezt'
	);
	$query = "SELECT m.id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."logins as l ON m.id=l.id
				WHERE email != '' AND l.anmeldename IS NOT NULL AND l.freigeschaltet = 1 ORDER BY name";
	$_db->holeDaten($query);
	$_mitglieder = $_db->baueArray('name','id');

	if(!isset($_POST['speichern'])){
		$daten = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
		$daten['textteile']['begruessung'] = str_replace('[br]',"\n",$daten['textteile']['begruessung']);
		$daten['textteile']['verabschiedung'] = str_replace('[br]',"\n",$daten['textteile']['verabschiedung']);
	}
	else{
		require_once($include_pfad.'func/pruefen.inc.php');
		$f = '';
		# Absender
		$_POST['absender']['name'] = trim($_POST['absender']['name']);
		$_POST['absender']['email'] = trim($_POST['absender']['email']);
		$f .= pruefen($_POST['absender']['name'],'leer','Der Absendername fehlt');
		$f .= pruefen($_POST['absender']['name'],'maxlaenge','Der Absendername ist zu lang (max. 100 Zeichen)',100);
		$f .= pruefen($_POST['absender']['email'],'leer','Die Absenderadresse fehlt');
		$f .= pruefen($_POST['absender']['email'],'email','Die Absenderadresse ist ungültig');
		$f .= pruefen($_POST['absender']['email'],'maxlaenge','Die Absenderadresse ist zu lang (max. 100 Zeichen)',100);
		# Cronjob
		if(count($_mitglieder)>0){
			$f .= pruefen($_POST['cronjob']['empfaenger_statusmeldung'],'wertemenge',
			'Der Empfänger für die Statusmeldungen ist ungültig',array_keys($_mitglieder));
		}
		else{
			$_POST['cronjob']['empfaenger_statusmeldung'] = '';
		}
		# Sonstiges
		$_POST['sonstiges']['fparameter'] = trim($_POST['sonstiges']['fparameter']);
		$f .= pruefen($_POST['sonstiges']['fparameter'],'email','Der -f-Parameter ist ungültig');
		$f .= pruefen($_POST['sonstiges']['fparameter'],'maxlaenge','Der -f-Parameter ist zu lang (max. 100 Zeichen)',100);
		$f .= pruefen($_POST['sonstiges']['dusie'],'wertemenge','Der Sie/Du-Wert ist ungültig',array_keys($_dusie));
		# Betreff
		$_POST['betreff']['kennung_cronjob'] = trim($_POST['betreff']['kennung_cronjob']);
		$_POST['betreff']['zugangsdaten'] = trim($_POST['betreff']['zugangsdaten']);
		$f .= pruefen($_POST['betreff']['kennung_cronjob'],'maxlaenge','Die Kennung für die Cronjobmails ist zu lang (max. 30 Zeichen)',30);
		$f .= pruefen($_POST['betreff']['zugangsdaten'],'leer','Der Betreff für die Zugangsdatenmails fehlt');
		$f .= pruefen($_POST['betreff']['zugangsdaten'],'maxlaenge','Der Betreff für die Zugangsdatenmails ist zu lang (max. 200 Zeichen)',200);
		# Textteile
		$f .= pruefen($_POST['textteile']['begruessung'],'leer','Die Begrüßung fehlt');
		$f .= pruefen($_POST['textteile']['begruessung'],'maxlaenge','Die Begrüßung ist zu lang (max. 500 Zeichen)',500);
		$f .= pruefen($_POST['textteile']['verabschiedung'],'leer','Die Verabschiedung fehlt');
		$f .= pruefen($_POST['textteile']['verabschiedung'],'maxlaenge','Die Verabschiedung ist zu lang (max. 500 Zeichen)',500);
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$daten = $_POST;
		}
		else{
			$einstellungen = array(
				'absender'  => array('name','email'),
				'cronjob'   => array('empfaenger_statusmeldung'),
				'sonstiges' => array('fparameter','dusie'),
				'betreff'   => array('kennung_cronjob','zugangsdaten'),
				'textteile' => array('begruessung','verabschiedung')
			);
			foreach($einstellungen as $kat => $unterkat){
				$conf[$kat] = array();
				foreach($unterkat as $wert){
					$conf[$kat][$wert] = $_POST[$kat][$wert];
				}
			}
			if(!empty($conf['betreff']['kennung_cronjob'])){
				$conf['betreff']['kennung_cronjob'] .= ' ';
			}
			$conf['textteile']['begruessung'] = preg_replace("/(\015\012)|(\015)|(\012)/",'[br]',$conf['textteile']['begruessung']);
			$conf['textteile']['verabschiedung'] = preg_replace("/(\015\012)|(\015)|(\012)/",'[br]',$conf['textteile']['verabschiedung']);
			require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei($include_pfad.'conf/emails.ini',$conf,true);
			weiterleiten('/admin.php','Die Einstellungen wurden gespeichert.');
		}
	}
	if(count($_mitglieder)){
		$_tmpl->assign('_mitglieder',$_mitglieder);
	}
	$_tmpl->assign('_dusie',$_dusie);
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-email.inc.html');
	break;

case 'cronjob':
	if(!is_writable($include_pfad.'conf/cronjob.ini')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/cronjob.ini) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	$zweimalimmonat = array(
		'115'  => '1. und 15. jeden Monats',     '13mo' => '1. und 3. Montag im Monat',     '13di' => '1. und 3. Dienstag im Monat',
		'13mi' => '1. und 3. Mittwoch im Monat', '13do' => '1. und 3. Donnerstag im Monat', '13fr' => '1. und 3. Freitag im Monat',
		'13sa' => '1. und 3. Samstag im Monat',  '13so' => '1. und 3. Sonntag im Monat',    '24mo' => '2. und 4. Montag im Monat',
		'24di' => '2. und 4. Dienstag im Monat', '24mi' => '2. und 4. Mittwoch im Monat',   '24do' => '2. und 4. Donnerstag im Monat',
		'24fr' => '2. und 4. Freitag im Monat',  '24sa' => '2. und 4. Samstag im Monat',    '24so' => '2. und 4. Sonntag im Monat'
	);
	$monatlich = array(
		'ersten' => 'Monatsersten',        '1mo' => '1. Montag im Monat',     '1di' => '1. Dienstag im Monat',
		'1mi' => '1. Mittwoch im Monat',   '1do' => '1. Donnerstag im Monat', '1fr' => '1. Freitag im Monat',
		'1sa' => '1. Samstag im Monat',    '1so' => '1. Sonntag im Monat',    '2mo' => '2. Montag im Monat',
		'2di' => '2. Dienstag im Monat',   '2mi' => '2. Mittwoch im Monat',   '2do' => '2. Donnerstag im Monat',
		'2fr' => '2. Freitag im Monat',    '2sa' => '2. Samstag im Monat',    '2so' => '2. Sonntag im Monat',
		'3mo' => '3. Montag im Monat',     '3di' => '3. Dienstag im Monat',   '3mi' => '3. Mittwoch im Monat',
		'3do' => '3. Donnerstag im Monat', '3fr' => '3. Freitag im Monat',    '3sa' => '3. Samstag im Monat',
		'3so' => '3. Sonntag im Monat',    '4mo' => '4. Montag im Monat',     '4di' => '4. Dienstag im Monat',
		'4mi' => '4. Mittwoch im Monat',   '4do' => '4. Donnerstag im Monat', '4fr' => '4. Freitag im Monat',
		'4sa' => '4. Samstag im Monat',    '4so' => '4. Sonntag im Monat',    'letzen' => 'Monatsletzten'
	);
	$sicherbarepfade = array(
		'PFAD_INCLUDEbilder_speicher/:bilder_speicher/' => ' Bildercache (bilder_speicher)',
		'PFAD_INCLUDEconf/:conf/'                       => ' Einstellungsdateien (conf)',
		'PFAD_INCLUDEdateien/:dateien/'                 => ' Dateien aus der Dateiverwaltung (dateien)',
		'PFAD_INCLUDEini_speicher/:ini_speicher/'       => ' user- oder wettkampfspezifische Einstellungsdateien (ini_speicher)'
	);
	$erlaubteintervalle = array(
		'austritte'          => array('taeglich','woechentlich','zweimalimmonat','monatlich','nie'),
		'feiertageanlegen'   => array('woechentlich','zweimalimmonat','monatlich','nie'),
		'tabellenoptimieren' => array('woechentlich','zweimalimmonat','monatlich','nie'),
		'dbsichern'          => array('taeglich','woechentlich','zweimalimmonat','monatlich'),
		'dateiensichern'     => array('taeglich','woechentlich','zweimalimmonat','monatlich'),
		'gc'                 => array('woechentlich','zweimalimmonat','monatlich'),
		'aktuellezeiten'     => array('woechentlich','zweimalimmonat','monatlich')
	);
	$standardintervalle = array(
		'intervall'                => 'monatlich',
		'zeitpunkt_woechentlich'   => '1',
		'zeitpunkt_zweimalimmonat' => '115',
		'zeitpunkt_monatlich'      => 'ersten',
	);

	if(!isset($_POST['speichern'])){
		$daten = array();
		$conf = parse_ini_file(PFAD_INCLUDE.'conf/cronjob.ini',true);
		# Zeitpunkte
		$daten['zeitpunkte'] = array();
		foreach($conf['zeitpunkte'] as $aktion => $wert){
			$daten['zeitpunkte'][$aktion] = $standardintervalle;
			if(strpos($wert,':')===false){
				$daten['zeitpunkte'][$aktion]['intervall'] = $wert;
				continue;
			}
			list($interval, $zeitpunkt) = explode(':',$wert);
			$daten['zeitpunkte'][$aktion]['intervall'] = $interval;
			$daten['zeitpunkte'][$aktion]['zeitpunkt_'.$interval] = $zeitpunkt;
		}
		# zu sichernde Verzichenisse
		$daten['zusicherndeverzeichnisse'] = $conf['zusicherndeverzeichnisse'];
		# gc
		$daten['gc'] = array();
		foreach($conf['gc'] as $gc => $wert){
			if(in_array($gc,array('tmpdateien','wettkampfabwicklungsdateien'))){
				$daten['gc'][$gc] = $wert;
				continue;
			}
			$daten['gc'][$gc.'_optionen'] = array();
			$aktionen = explode(';',$wert);
			foreach($aktionen as $aktion){
				if(strpos($aktion,':')!==false){
					list($a,$w) = explode(':',$aktion);
					$daten['gc'][$gc][] = $a;
					$daten['gc'][$gc.'_optionen'][$a] = $w;
				}
				else{
					$daten['gc'][$gc][] = $aktion;
				}
			}
		}
		# sonstiges
		$daten['einstellungen'] = $conf['einstellungen'];
		$daten['einstellungen']['aufrufvonip'] = str_replace(',',', ',$daten['einstellungen']['aufrufvonip']);
		$daten['flags'] = $conf['flags'];
	}
	else{
		require_once($include_pfad.'func/pruefen.inc.php');
		$f = '';
		# Zeitpunkte
		foreach($erlaubteintervalle as $aktion => $erlaubt){
			if(!isset($_POST['zeitpunkte'][$aktion])){
				$f .= $aktion.' fehlt<br />';
				continue;
			}
			$a = &$_POST['zeitpunkte'][$aktion];
			if(!isset($a['intervall'])){
				$f .= 'Das gewählte Intervall ist für die Aktion »'.$aktion.'« fehlt<br />';
				continue;
			}
			if(!in_array($a['intervall'],$erlaubt)){
				$f .= 'Das gewählte Intervall ist für die Aktion »'.$aktion.'« nicht erlaubt oder ungültig<br />';
				continue;
			}
			switch($a['intervall']){
			case 'woechentlich':
				if(!isset($a['zeitpunkt_woechentlich']) or !in_array($a['zeitpunkt_woechentlich'],array_keys($_wochentage))){
					$f .= 'Der Zeitpunkt für die Aktion »'.$aktion.'« fehlt oder ist ungültig.<br />';
				}
				$a['zeitpunkt_zweimalimmonat'] = $standardintervalle['zeitpunkt_zweimalimmonat'];
				$a['zeitpunkt_monatlich'] = $standardintervalle['zeitpunkt_monatlich'];
				break;
			case 'zweimalimmonat':
				if(!isset($a['zeitpunkt_zweimalimmonat']) or !in_array($a['zeitpunkt_zweimalimmonat'],array_keys($zweimalimmonat))){
					$f .= 'Der Zeitpunkt für die Aktion »'.$aktion.'« fehlt oder ist ungültig.<br />';
				}
				$a['zeitpunkt_woechentlich'] = $standardintervalle['zeitpunkt_woechentlich'];
				$a['zeitpunkt_monatlich'] = $standardintervalle['zeitpunkt_monatlich'];
				break;
			case 'monatlich':
				if(!isset($a['zeitpunkt_monatlich']) or !in_array($a['zeitpunkt_monatlich'],array_keys($monatlich))){
					$f .= 'Der Zeitpunkt für die Aktion »'.$aktion.'« fehlt oder ist ungültig.<br />';
				}
				$a['zeitpunkt_woechentlich'] = $standardintervalle['zeitpunkt_woechentlich'];
				$a['zeitpunkt_zweimalimmonat'] = $standardintervalle['zeitpunkt_zweimalimmonat'];
				break;
			}
		}
		# zusicherndeverzeichnisse
		foreach($_POST['zusicherndeverzeichnisse'] as $key => $verz){
			if(!in_array($verz,array_keys($sicherbarepfade))){
				$f .= 'Der angegebene, zu sichernde Pfad ist ungültig<br />';
			}
		}
		# gc
		if(!isset($_POST['gc']['zeitenentwicklungbilder'])){
			$f .= 'Es muss mindestens ein garbage collector zum Löschen von Zeitenentwicklungsbildern definiert sein<br />';
		}
		else{
			foreach($_POST['gc']['zeitenentwicklungbilder'] as $gc){
				if(!in_array($gc,array('aelterals','ausgetretene','groesserals'))){
					$f .= 'Die gewählte Aktion zum Löschen von Zeitenentwicklungsbildern ist ungültig<br />';
					continue;
				}
				switch($gc){
				case 'aelterals':
					$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['aelterals'],'zahl',
						'Die Anzahl der Tage beim Zeitenentwicklungsbilder-gc ist keine ganze Zahl');
					break;
				case 'groesserals':
					$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'],'leer',
						'Die maximale Größe der Bilder beim Zeitenentwicklungsbilder-gc fehlt');
					$f .= pruefen($_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'],'regexpr',
						'Die maximale Größe der Bilder beim Zeitenentwicklungsbilder-gc ist keine Zahl','^[0-9](?:[.,][0-9]{1,2})?$');
					break;
				default:
					break;
				}
			}
		}
		$f .= pruefen($_POST['gc']['tmpdateien'],'leer','Die Anzahl der Tage für den gc der temporären Dateien fehlt');
		$f .= pruefen($_POST['gc']['tmpdateien'],'zahl','Die Anzahl der Tage für den gc der temporären Dateien ist keine gültige ganz Zahl');
		$f .= pruefen($_POST['gc']['wettkampfabwicklungsdateien'],'leer','Die Anzahl der Jahre für den gc der WK-Abwicklungsdateien fehlt');
		$f .= pruefen($_POST['gc']['wettkampfabwicklungsdateien'],'zahl','Die Anzahl der Jahre für den gc der WK-Abwicklungsdateien ist keine gültige ganz Zahl');
		# sonstiges
		$_POST['einstellungen']['aufrufvonip'] = str_replace(' ','',$_POST['einstellungen']['aufrufvonip']);
		$f .= pruefen($_POST['einstellungen']['aufrufvonip'],'regexpr','mindestens eine der eingegebenen IPs ist ungültig',
		'^([0-9]{1,3}(\.[0-9]{1,3}){3})(,[0-9]{1,3}(\.[0-9]{1,3}){3})*$');

		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_POST['einstellungen']['aufrufvonip'] = str_replace(',',', ',$_POST['einstellungen']['aufrufvonip']);
			$daten = $_POST;
		}
		else{
			$conf = array();
			# zeitpunkte
			$conf['zeitpunkte'] = array();
			foreach($_POST['zeitpunkte'] as $zeitpunkt => $aktion){
				$conf['zeitpunkte'][$zeitpunkt] = $aktion['intervall'];
				if(in_array($aktion['intervall'],array('woechentlich','zweimalimmonat','monatlich'))){
					$conf['zeitpunkte'][$zeitpunkt] .= ':'.$aktion['zeitpunkt_'.$aktion['intervall']];
				}
			}
			# zusicherndeverzeichnisse
			$conf['zusicherndeverzeichnisse'] = array();
			foreach($_POST['zusicherndeverzeichnisse'] as $verz){
				$conf['zusicherndeverzeichnisse'][] = $verz;
			}
			# gc
			$conf['gc'] = array();
			$conf['gc']['zeitenentwicklungbilder'] = '';
			$_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals'] = str_replace(',','.',$_POST['gc']['zeitenentwicklungbilder_optionen']['groesserals']);
			foreach($_POST['gc']['zeitenentwicklungbilder'] as $aktion){
				$conf['gc']['zeitenentwicklungbilder'] .= (empty($conf['gc']['zeitenentwicklungbilder'])?'':';').$aktion;
				if(isset($_POST['gc']['zeitenentwicklungbilder_optionen'][$aktion])){
					$conf['gc']['zeitenentwicklungbilder'] .= ':'.$_POST['gc']['zeitenentwicklungbilder_optionen'][$aktion];
				}
			}
			$conf['gc']['tmpdateien'] = $_POST['gc']['tmpdateien'];
			$conf['gc']['wettkampfabwicklungsdateien'] = $_POST['gc']['wettkampfabwicklungsdateien'];
			# sonstiges
			$conf['einstellungen'] = array();
			$conf['flags'] = array();
			$conf['einstellungen']['aufrufvonip'] = $_POST['einstellungen']['aufrufvonip'];
			$conf['flags']['userconfeinlesen'] = isset($_POST['flags']['userconfeinlesen'])?1:0;
			$conf['flags']['komplettsicherung'] = isset($_POST['flags']['komplettsicherung'])?1:0;
			$conf['flags']['zeitenentwicklungsbilderloeschen'] = isset($_POST['flags']['zeitenentwicklungsbilderloeschen'])?1:0;
			$conf['flags']['vereinsrekordeeinlesen'] = isset($_POST['flags']['vereinsrekordeeinlesen'])?1:0;
			# cronjob.ini schreiben und weiterleiten
			require_once($include_pfad.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei($include_pfad.'conf/cronjob.ini',$conf,true);
			weiterleiten('/admin.php','Die Änderungen wurden gespeichert.');
		}
	}
	$_tmpl->assign('_sicherbarepfade',$sicherbarepfade);
	$_tmpl->assign('_zweimalimmonat',$zweimalimmonat);
	$_tmpl->assign('_monatlich',$monatlich);
	$_tmpl->assign('_wochentage',$_wochentage);
	$_tmpl->assign('_monate',$_monate);
	if(!isset($daten['gc']['zeitenentwicklungbilder'])){
		$daten['gc']['zeitenentwicklungbilder'] = array();
	}
	$_tmpl->assign('daten',$daten);
	$_inh .= $_tmpl->fetch('admin/29.admin-cronjob.inc.html');
	break;

case 'dbdaten':
	if(!is_writable($include_pfad.'conf/conf.inc.php')){
		$_tmpl->assign('fehler','Die Konfigurationsdatei ([include_path]/conf/conf.inc.php) ist nicht beschreibbar, Änderungen müssen von Hand gemacht werden.');
		if(isset($_POST['speichern'])){
			unset($_POST['speichern']);
		}
	}
	if(isset($_POST['speichern'])){
		require_once($include_pfad.'func/pruefen.inc.php');
		$f = '';
		$f .= pruefen($_POST['daten']['db_server'],'maxlaenge','Der Servername ist zu lang (max. 200 Zeichen)',200);
		$f .= pruefen($_POST['daten']['db_benutzername'],'maxlaenge','Der Benutzername ist zu lang (max. 200 Zeichen)',200);
		$f .= pruefen($_POST['daten']['db_passwort'],'maxlaenge','Das Passwort ist zu lang (max. 200 Zeichen)',200);
		$f .= pruefen($_POST['daten']['db_name'],'maxlaenge','Der Datenbankname ist zu lang (max. 200 Zeichen)',200);
		$f .= pruefen($_POST['daten']['db_prefix'],'maxlaenge','Das Tabellenprefix ist zu lang (max. 20 Zeichen)',20);
		$f .= pruefen($_POST['daten']['db_prefix'],'regexpr','Das Tabellenprefix darf nur aus den Zeichen a-z0-9_ bestehen.','^[a-zA-Z0-9_]+$');

		if(empty($f)){
			# bei geaendertem DB_PREFIX Tabellen umbenennen
			if($_POST['daten']['db_prefix'] != DB_PREFIX and $_POST['daten']['db_name'] == DB_NAME){
				$dat = &$_POST['daten'];
				$_db = new db;
				$_db->tmpl = &$_tmpl;
				$_db->schreibschutz = false;
				$_db->setzeDbParameter($dat['db_server'], $dat['db_benutzername'], $dat['db_passwort'], $dat['db_name']);
				$_db->verbindeMitDb();
				$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
				$_db->holeDaten($query, E_USER_ERROR, 'row');
				$tabellen = $_db->baueArray('0','0');
				foreach($tabellen as $tabelle){
					$alt = $tabelle;
					$neu = $dat['db_prefix'].substr($tabelle,strlen(DB_PREFIX));
					$query = "ALTER TABLE ".$alt." RENAME TO ".$neu."";
					$_db->fuehreQueryAus($query);
				}
				# log/dbaenderungen.ini zuruecksetzen
				$fh = fopen($include_pfad.'log/dbaenderungen.ini','w');
				fclose($fh);
			}
			# conf-Datei schreiben
			$daten = array(
				'db_server'        => $_POST['daten']['db_server'],
				'db_benutzername'  => $_POST['daten']['db_benutzername'],
				'db_passwort'      => $_POST['daten']['db_passwort'],
				'db_name'          => $_POST['daten']['db_name'],
				'db_prefix'        => $_POST['daten']['db_prefix']
			);
			$_tmpl->assign('daten',$daten);
			$confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
			$fh = fopen($include_pfad.'conf/conf.inc.php','w');
			fwrite($fh, $confinhalt, strlen($confinhalt));
			fclose($fh);
			weiterleiten('/admin.php','Die Änderungen wurden gespeichert.');
		}
		else{
			$_tmpl->assign('fehler',$f);
			$daten = $_POST['daten'];
		}
	}
	else{
		$daten = array(
			'db_server'        => DB_SERVER,
			'db_benutzername'  => DB_BENUTZERNAME,
			'db_passwort'      => DB_PASSWORT,
			'db_name'          => DB_NAME,
			'db_prefix'        => DB_PREFIX
		);
	}
	$_tmpl->assign('daten',$daten);
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui');
	if(is_dir(PFAD_INCLUDE)){
		$_tmpl->tk_javascriptzuweisen('onready', "\$('#verbindungstest').dialog({
    bgiframe: true, autoOpen: false, modal: true, width: 'auto', minHeight:50,
    closeText: '×', height: 'auto', resizable: false, title: 'Ergebnis des Verbindungstests'
  });");
		$_tmpl->tk_javascriptzuweisen('inline', "function dbdatentesten(){
  \$.post(ajaxdatei, {
    mimeType:'text/xml', aktion:'dbverbindungtesten', server: \$('#server').val(),
    benutzername: \$('#benutzername').val(), passwort: \$('#passwort').val(), name: \$('#name').val()
  },
  function(a){
    var erfolg = \$('erfolg', a).text();
    \$('#erfolgreich').css('display', erfolg==1?'block':'none');
    \$('#fehler').css('display', erfolg==0?'block':'none');
    \$('#meldung').text($('meldung', a).text());
    \$('#verbindungstest').dialog('open');
  },'xml');
}");
	}
	$_inh .= $_tmpl->fetch('admin/29.admin-dbdaten.inc.html');
	break;

case 'userconfdefault':
	require_once($include_pfad.'class/einstellungen.inc.php');
	require_once(PFAD_INCLUDE.'conf/user-ini.php');
	$einst = new einstellungen('user','default');
	$einst->db = &$_db;
	$_tmpl->assign('bodyid','einstellungen');

	foreach($_usereinstellungen as $mid => $modul){
		foreach($modul as $oid => $option){
			if($option['art'] != 'datei'){
				continue;
			}
			$fh = opendir($option['verzeichnis']);
			$tmp_dateien = array();
			while(false !== ($file = readdir($fh))){
				if($file == '.' or $file == '..' or is_dir($file)){
					continue;
				}
				$tmp_dateien[] = $file;
			}
			closedir($fh);
			$dateien = array();
			foreach($tmp_dateien as $datei){
				$fh = fopen($option['verzeichnis'].$datei,'r');
				$anfang = fread($fh,300);
				fclose($fh);
				preg_match('~\[\[sichtbar=(1|0)\|name=(.*?)\]\]~',$anfang,$match);
				if(isset($match[1]) and $match[1] == 1){
					$dateien[$datei] = $match[2];
				}
			}
			$_usereinstellungen[$mid][$oid]['werte'] = $dateien;
		}
	}
	$_tmpl->assign('daten',  $_usereinstellungen);
	$_tmpl->assign('module', $_usereinstellungen_module);
	if(isset($_POST['speichern'])){
		$f = '';
		foreach($_usereinstellungen as $mid => $modul){
			if(!pruefeRechte($_usereinstellungen_module[$mid]['recht'])){
				continue;
			}
			foreach($modul as $oid => $option){
				if(isset($option['recht']) and !pruefeRechte($option['recht'])){
					continue;
				}
				switch($_usereinstellungen[$mid][$oid]['art']){
				case 'bool':
					$_POST['werte'][$mid][$oid] = isset($_POST['werte'][$mid][$oid])?1:0;
					break;
				case 'text':
					if(preg_match('~^'.$_usereinstellungen[$mid][$oid]['form'].'$~', $_POST['werte'][$mid][$oid], $match) == 0){
						$f .= $_usereinstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				case 'select':
				case 'datei':
					if(!array_key_exists($_POST['werte'][$mid][$oid], $_usereinstellungen[$mid][$oid]['werte'])){
						$f .= $_usereinstellungen[$mid][$oid]['fehler'].'<br />';
					}
					break;
				}
			}
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
			$_tmpl->assign('werte', $_POST['werte']);
		}
		else{
			$_werte = parse_ini_file($einst->userconfpfad.$einst->userdatei, true);
			foreach($_usereinstellungen as $mid => $modul){
				foreach($modul as $oid => $option){
					if(isset($_POST['werte'][$mid][$oid])){
						$_werte[$mid][$oid] = $_POST['werte'][$mid][$oid];
					}
				}
			}
			#pri ntr($_werte);exit;
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei($einst->userconfpfad.$einst->userdatei, $_werte, true);
			weiterleiten('/admin.php?aktion=userconfdefault','Die Einstellungen wurden gespeichert');
		}
	}
	else{
		$_werte = parse_ini_file($einst->userconfpfad.$einst->userdatei, true);
		if(count($_werte)<1){
			$_werte = array();
			foreach($_usereinstellungen as $mid => $modul){
				$_werte[$mid] = array();
				foreach($modul as $oid => $option){
					$_werte[$mid][$oid] = $option['standard'];
				}
			}
			$_SESSION['hinweis'] = 'Es sind noch keine Einstellungen gespeichert, die Standardeinstellungen wurden geladen.';
		}
		$_tmpl->assign('werte', $_werte);
	}

	$_inh .= $_tmpl->fetch('sonstiges/62.einstellungen-formular.inc.html');
	break;

default:
	$_inh .= $_tmpl->fetch('admin/29.index.inc.html');
	break;
}
} # Ende Rechte-else

# Loginformular
if(!isset($_SESSION['eingelogt']) or $_SESSION['eingelogt']=='auto'){
	$login = '';
	if(($_seite=='admin' and PFAD_HTTP=='') or !is_dir(PFAD_HTTP) or !defined('TKSWIM_DATEIENDUNG')){
		$url = '/admin.php';
	}
	else{
		$url = '/login'.TKSWIM_DATEIENDUNG.'';
		if(strpos($_SERVER['PHP_SELF'],'login.php') === false){
			$ps = $_SERVER['PHP_SELF']=='/index.php'?'':$_SERVER['PHP_SELF'];
			if(TKSWIM_DATEIENDUNG=='.html' and substr($ps,-4)=='.php'){
				$ps = substr($ps,0,-4).TKSWIM_DATEIENDUNG;
			}
			$_SESSION['vonseite'] = $ps.(!empty($_SERVER['QUERY_STRING'])?'?'.$_SERVER['QUERY_STRING']:'');
		}
	}
	$login .= '<form action="'.ROOT.$url.'" method="post" class="anmeldeform">';
	$login .= '<fieldset><legend>Login</legend>';
	if(!empty($_SESSION['fehler'])){
		$login .= '<p class="fehler">'.$_SESSION['fehler'].'</p>';
	}
	$login .= '<p>';
	$v = isset($_POST['loginanmeldename'])?text_format($_POST['loginanmeldename'],'value'):'';
	$login .= '<label>Benutzername: <input type="text" size="15" name="loginanmeldename"'.$v.' /></label><br />';
	$login .= '<label>Passwort: <input type="password" size="15" name="loginpasswort" /></label><br />';
	$login .= '<input type="hidden" name="anmelden" value="1" />';
	$login .= '<input type="submit" value="Anmelden" />';
	$login .= '</p><p>';
	if(ROOT_HTTPS != '-'){
		$https = (ROOT_HTTP==ROOT);
		$login .= '<a href="'.($https?ROOT_HTTPS:ROOT_HTTP).$url.'" title="über eine verschlüsselte Verbindung auf tkswim zugreifen">HTTP'.($https?'S':'').'&nbsp;verwenden</a> ';
	}
	$login .= '<a href="'.ROOT.'/?passwortvergessen">Passwort&nbsp;vergessen?</a>';
	$login .= '</p></fieldset></form>';
	$_inh = $login.$_inh;
}

if(isset($_db) and $_db !==false){
	$_db->speichereGeaenderteTabellen();
}
$_tmpl->assign('inhalt',$_inh);
$_tmpl->assign('s',$_seite);
if(count($_tmpl->tk_fussnoten) > 0){
	$_tmpl->assign('fussnoten',$_tmpl->tk_fussnoten);
}
# Hinweise
if(isset($_SESSION['hinweis'])){
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message');
	$_tmpl->tk_javascriptzuweisen('onready',"$('.nojs').css('display','none');");
	$_tmpl->tk_javascriptzuweisen('onready',"$().message('".text_format($_SESSION['hinweis'],'js')."');");
}

# Javascript zuweisen
$_tmpl->tk_javascriptvorbereiten();

$inhalt = $_tmpl->fetch('tmpl.inc.html');
if(!headers_sent()){
	header('x-Powered-By: tkswim');
	header('Content-Type: text/html; charset=utf-8');
}
if(isset($_einst) and $_einst['globaleeinstellungen']['inhaltkomprimiertausliefern']){
	ob_start('ob_gzhandler');
	echo $inhalt;
	ob_end_flush();
}
else{
	echo $inhalt;
}

if(isset($_SESSION['hinweis'])){
	unset($_SESSION['hinweis']);
}
# EOF
?>
