<?php
$_seite = 'admin';
require_once('./__inc/_start.inc.php');
if(!isset($_SESSION['adminlogin'])){
	weiterleiten('/');
}
$_tmpl->assign('ueberschrift','Updates');

$aktuelleversion = '0.9.5';

$vorhandeneupdates = array(
	'0.8.9' => '0.8.10', '0.8.10' => '0.8.11', '0.8.11' => '0.8.12', '0.8.12' => '0.8.13',
	'0.8.13' => '0.8.14', '0.8.14' => '0.9', '0.9' => '0.9.1', '0.9.1' => '0.9.2',
	'0.9.2' => '0.9.3', '0.9.3' => '0.9.4', '0.9.4' => '0.9.5'
);

if(isset($_GET['aktion'])){
	switch($_GET['aktion']){
	case 'handbuch':
		$url = 'http://tkswim.de/daten.php?inhalt=neueversion&version='.TKSWIM_VERSION;
		$url_handbuch = 'http://tkswim.de/download/anwenderhandbuch.pdf';
		$meldung = '';
		$ok = false;
		if(ini_get('allow_url_fopen') != 1){
			$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
		}
		else{
			$daten = file_get_contents($url);
			if($daten === false){
				$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
			}
			else{
				$xml = new SimpleXMLElement($daten);
				foreach($xml->version as $version){
					if((string)$version['modul'] != 'anwenderhandbuch'){
						continue;
					}
					$verfuegbar = (string)$version['version'];
				}
				$query = "SELECT DATE_FORMAT(letzteaenderung, '%Y.%m.%d') as version FROM ".DB_PREFIX."dateien WHERE id = 1";
				$_db->holeDaten($query);
				$installiert = $_db->holeWert();
				if(version_compare($installiert, $verfuegbar, '>=')){
					$meldung = 'Es ist bereits die aktuelle Version des Handbuchs installiert.';
					$_inh .= '<p><a href="'.ROOT.'/admin/?aktion=neueversion">zurück zur Versionskontrolle</a></p>';
				}
				else{
					$handbuch = file_get_contents($url_handbuch);
					if($daten === false){
						$meldung = 'Das Handbuch konnte nicht geladen werden, bitte manuell von tkswim.de runterladen und in tkswim hochladen.';
					}
					else{
						$fh = fopen(PFAD_DATEIEN.'anwenderhandbuch.pdf', 'w');
						fwrite($fh, $handbuch);
						fclose($fh);
						$query = "UPDATE ".DB_PREFIX."dateien SET groesse = ".filesize(PFAD_DATEIEN.'anwenderhandbuch.pdf').", letzteaenderung = NOW() WHERE id = 1";
						$_db->fuehreQueryAus($query);
						weiterleiten('/update.php', 'die aktuelle Version des Handbuchs wurde heruntergeladen');
					}
				}
			}
		}
		weiterleiten('/update.php', 'Fehler: '.$meldung);

	case 'templatecache':
		$erg = leereTemplateCache();
		weiterleiten('/update.php', $erg?'Der Template-Cache wurde geleert':'Der Template-Cache konnte nicht geleert werden');

	default:
		weiterleiten('/update.php');
	}
}

if(isset($_GET['update']) and $_GET['update']=='module'){
	$_tmpl->assign('ueberschrift','Module aktualisieren');
	
	# Updates bei den Rechten von Modulen übernehmen
	$module = parse_ini_file(PFAD_INCLUDE.'conf/module.ini', true);
	$_module = array();
	$_bereiche = array(
		'wkabwickeln' => 'Wettkampfabwicklung',
		'sonstiges' => 'Sonstiges',
		'code' => 'Code'
	);
	$updatenoetig = false;
	if(count($module['_versionen']) > 0){
		ksort($module['_versionen']);
		foreach($module['_versionen'] as $modul => $version){
			$modulconf = parse_ini_file(PFAD_INCLUDE.'module/'.$modul.'/conf.ini', true);
			$modulconf['conf']['tkswimversion_bis'] = str_replace('*','99',$modulconf['conf']['tkswimversion_bis']);
			$_module[$modul] = array(
				'installiert' => $version,
				'verfuegbar' => $modulconf['conf']['version'],
				'updatenoetig' => version_compare($version, $modulconf['conf']['version'], '<'),
				'modulverwendbar' => (version_compare(TKSWIM_VERSION, $modulconf['conf']['tkswimversion_ab'], '>=') and version_compare(TKSWIM_VERSION, $modulconf['conf']['tkswimversion_bis'], '<=')),
				'bereich' => $_bereiche[$modulconf['conf']['bereich']],
				'bezeichnung' => str_replace(' ','&nbsp;',$modulconf['conf']['name'])
			);
			if($_module[$modul]['updatenoetig']){
				$updatenoetig = true;
			}
		}
		
		if(isset($_GET['modul']) and isset($_module[$_GET['modul']]) and $_module[$_GET['modul']]['updatenoetig']){
			$modulconf = parse_ini_file(PFAD_INCLUDE.'module/'.$_GET['modul'].'/conf.ini', true);
			$module['_versionen'][$_GET['modul']] = $modulconf['conf']['version'];
			if(count($modulconf['rechte']) > 0){
				# prüfen ob neue Rechte angelegt werden müssen
				$rechte = $modulconf['rechte'];
				# vorhandene Rechte holen
				$query = "SELECT id FROM ".DB_PREFIX."rechte WHERE id IN ('".implode("', '", array_keys($rechte))."')";
				$_db->holeDaten($query);
				$vorhandenerechte = $_db->baueArray('id', 'id');
				# aus $rechte die entfernen die schon vorhanden sind
				foreach($vorhandenerechte as $id){
					unset($rechte[$id]);
				}
				# wenn in $rechte noch Rechte stehen müssen die noch angelegt werden
				if(count($rechte) > 0){
					$rgr = $r = array();
					foreach($rechte as $id => $dat){
						list($sort, $bezeichnung) = explode(';', $dat, 2);
						$r[] = "('".text_format($id,'db')."', '".text_format($sort,'db')."', '".text_format($bezeichnung,'db')."')";
						$rgr[] = "(1, '".text_format($id,'db')."')";
					}
					# fehlende Rechte anlegen und der Rechtegruppe Admin zuordnen
					$query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ', $r)."";
					$_db->fuehreQueryAus($query);
					$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ', $rgr)."";
					$_db->fuehreQueryAus($query);
				}
			}
			require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
			schreibe_ini_datei(PFAD_INCLUDE.'conf/module.ini', $module, true);
			weiterleiten('/update.php?update=module', 'Das Update wurde installiert');
		}	
	}
	
	$_tmpl->assign('updatenoetig', $updatenoetig);
	$_tmpl->assign('module', $_module);
	$_inh .= $_tmpl->fetch('admin/29.admin-update-module.inc.html');
}
elseif(!isset($_GET['update']) or ($_GET['update']!='aktuell' and !file_exists(PFAD_INCLUDE.'code/update.'.str_replace('.','-',$_GET['update']).'.inc.php'))){
	$anzeige = array();
	foreach($vorhandeneupdates as $von => $nach){
		if(!file_exists(PFAD_INCLUDE.'code/update.'.str_replace('.','-',$nach).'.inc.php')){
			continue;
		}
		$anzeige[] = array(
			'von' => $von,
			'nach' => $nach
		);
	}
	function updatesort($a, $b){
		return version_compare($a['nach'],$b['nach'],'<');
	}
	usort($anzeige,'updatesort');
	$_tmpl->assign('updates', $anzeige);

	# muss noch ein Update auf eine aktuelle Version installiert werden?
	$aktuell = true;
	if($aktuelleversion != TKSWIM_VERSION){
		$anzahl = 0;
		$zaehlen = false;
		foreach($vorhandeneupdates as $von => $nach){
			if(!$zaehlen and $von == TKSWIM_VERSION){
				$zaehlen = true;
			}
			if($zaehlen){
				$anzahl++;
			}
			if($nach == $aktuelleversion){
				break;
			}
		}
		$aktuell = array(
			'anzahl' => $anzahl,
			'von' => TKSWIM_VERSION,
			'nach' => $aktuelleversion
		);
	}
	# installierte Version ist zu alt
	if(is_array($aktuell) and $aktuell['anzahl'] == 0){
		reset($vorhandeneupdates);
		list($aktuell['min'],) = each($vorhandeneupdates);
	}

	# und raus damit
	$_tmpl->assign('aktuell', $aktuell);
	$_inh .= $_tmpl->fetch('admin/29.admin-update-index.inc.html');
}
elseif($_GET['update'] == 'aktuell'){ # Update auf die aktelle Version (auch über mehrere Versionen hinweg)
	# muss noch ein Update auf eine aktuelle Version installiert werden?
	$aktuell = true;
	if($aktuelleversion != TKSWIM_VERSION){
		$anzahl = 0;
		$zaehlen = false;
		foreach($vorhandeneupdates as $von => $nach){
			if(!$zaehlen and $von == TKSWIM_VERSION){
				$zaehlen = true;
			}
			if($zaehlen){
				$anzahl++;
			}
			if($nach == $aktuelleversion){
				break;
			}
		}
		$aktuell = array(
			'anzahl' => $anzahl,
			'von' => TKSWIM_VERSION,
			'nach' => $aktuelleversion
		);
	}
	# installierte Version ist zu alt
	if(is_array($aktuell) and $aktuell['anzahl'] == 0){
		reset($vorhandeneupdates);
		list($aktuell['min'],) = each($vorhandeneupdates);
	}

	if(isset($_POST['update']) and is_array($aktuell) and $aktuell['anzahl'] > 0){
		$hinweise = array();
		foreach($vorhandeneupdates as $von => $nach){
			if(version_compare($von, $aktuell['von'], '<') or version_compare($nach, $aktuell['nach'], '>')){
				continue;
			}

			require_once(PFAD_INCLUDE.'code/update.'.str_replace('.','-',$nach).'.inc.php');
			
			# Funktion ausführen (wenn sie am Anfang ausgeführt werden soll)
			if(isset($updates[$nach]['funktion']) and $updates[$nach]['funktion'] == 'anfang'){
				$funktion = 'update_'.str_replace('.','_',$nach);
				if(function_exists($funktion)){
					call_user_func($funktion);
				}
			}
			
			# Querys
			if(isset($updates[$nach]['querys']) and count($updates[$nach]['querys'])>0){
				$_db->holeDaten($updates[$nach]['kontrollquery']);
				$aktionen['querysausgefuehrt'] = $_db->holeWert()==1?true:false;
				if($_db->holeWert()!=1){
					foreach($updates[$nach]['querys'] as $query){
						$_db->fuehreQueryAus($query);
					}
				}
			}

			# neue Rechte
			if(isset($updates[$nach]['neuerechte']) and count($updates[$nach]['neuerechte'])>0){
				$query = "SELECT id FROM ".DB_PREFIX."rechte WHERE id IN ('".implode("','",array_keys($updates[$nach]['neuerechte']))."')";
				$_db->holeDaten($query);
				$vorhanden = $_db->baueArray('id','#');
				$r = $rgr = array();
				foreach($updates[$nach]['neuerechte'] as $id => $recht){
					if(in_array($id, $vorhanden)){
						continue;
					}
					$r[] = "('".$id."',".$recht['sort'].",'".$recht['bezeichnung']."')";
					$rgr[] = "(1, '".$id."')";
				}
				if(count($r)>0){
					$query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ',$r);
					$_db->fuehreQueryAus($query);
					$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ',$rgr);
					$_db->fuehreQueryAus($query);
				}
			}

			# neue Einstellungen
			if(isset($updates[$nach]['neueeinstellungen'])){
				if(isset($updates[$nach]['neueeinstellungen']['global']) and count($updates[$nach]['neueeinstellungen']['global'])>0){
					$einstellungen = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);
					$t = $updates[$nach]['neueeinstellungen']['global'][0];
					if(!isset($einstellungen[$t['gruppe']]) or !isset($einstellungen[$t['gruppe']][$t['einstellung']])){
						require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
						$einst = new einstellungen('global');
						$einst->db = &$_db;
						$einst->aktualisiereGlobalIniDatei();
					}
					unset($einstellungen, $t);
				}
				if(isset($updates[$nach]['neueeinstellungen']['user']) and count($updates[$nach]['neueeinstellungen']['user'])>0){
					$einstellungen = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini', true);
					$t = $updates[$nach]['neueeinstellungen']['user'][0];
					if(!isset($einstellungen[$t['gruppe']]) or !isset($einstellungen[$t['gruppe']][$t['einstellung']])){
						require_once(PFAD_INCLUDE.'conf/user-ini.php');
						require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
						$einst = new einstellungen('user','default');
						$einst->db = &$_db;
						$einst->aktualisiereUserinidateien();
					}
					unset($einstellungen, $t);
				}
			}

			# Dateien aktualisieren
			if(isset($updates[$nach]['dateienupdate']) and count($updates[$nach]['dateienupdate'])>0){
				foreach($updates[$nach]['dateienupdate'] as $datei){
					aktualisiereDatei($datei);
				}
			}

			# Hinweise
			if(isset($updates[$nach]['hinweise']) and count($updates[$nach]['hinweise'])>0){
				foreach($updates[$nach]['hinweise'] as $h){
					$hinweise[] = $h;
				}
			}
			
			# Funktion ausführen (wenn sie am Ende ausgeführt werden soll)
			if(isset($updates[$nach]['funktion']) and $updates[$nach]['funktion'] == 'ende'){
				$funktion = 'update_'.str_replace('.','_',$nach);
				if(function_exists($funktion)){
					call_user_func($funktion);
				}
			}
		}
		leereTemplateCache();

		aktualisiereDatei('config', array('tkswim_version'=>$aktuelleversion));

		if(count($hinweise)>0){
			$aktuell = true;
			$_tmpl->assign('hinweise', $hinweise);
		}
		else{
			weiterleiten('/update.php','Das Update auf die aktuelle Version wurde durchgeführt.');
		}
	}
	$_tmpl->assign('ueberschrift', 'Update auf die aktuelle Version');
	$_tmpl->assign('aktuell', $aktuell);
	$_inh .= $_tmpl->fetch('admin/29.admin-update-sammelupdate.inc.html');
}
else{ # genau ein Update von einer Version auf die folgende
	$_tmpl->assign('ueberschrift','Update auf Version '.$_GET['update']);
	# Aktionen des Updates sammeln
	require_once(PFAD_INCLUDE.'code/update.'.str_replace('.','-',$_GET['update']).'.inc.php');
	$aktionen = array();

	# Querys
	if(isset($updates[$_GET['update']]['querys']) and count($updates[$_GET['update']]['querys'])>0){
		$aktionen['querys'] = $updates[$_GET['update']]['querys'];
		$_db->holeDaten($updates[$_GET['update']]['kontrollquery']);
		$aktionen['querysausgefuehrt'] = $_db->holeWert()==1?true:false;

		if(!$aktionen['querysausgefuehrt'] and isset($_POST['querys'])){
			foreach($aktionen['querys'] as $query){
				$_db->fuehreQueryAus($query);
			}
			weiterleiten('/update.php?update='.$_GET['update']);
		}
	}

	# neue Rechte
	if(isset($updates[$_GET['update']]['neuerechte']) and count($updates[$_GET['update']]['neuerechte'])>0){
		$aktionen['neuerechte'] = $updates[$_GET['update']]['neuerechte'];
		$query = "SELECT id FROM ".DB_PREFIX."rechte WHERE id IN ('".implode("','",array_keys($aktionen['neuerechte']))."')";
		$_db->holeDaten($query);
		$aktionen['neuerechteangelegt'] = $_db->holeAnzahl()==count(array_keys($aktionen['neuerechte']))?true:false;

		if(!$aktionen['neuerechteangelegt'] and isset($_POST['neuerechte'])){
			$r = $rgr = array();
			foreach($aktionen['neuerechte'] as $id => $recht){
				$r[] = "('".$id."',".$recht['sort'].",'".$recht['bezeichnung']."')";
				$rgr[] = "(1, '".$id."')";
			}
			$query = "INSERT INTO ".DB_PREFIX."rechte (id, sort, bezeichnung) VALUES ".implode(', ',$r);
			$_db->fuehreQueryAus($query);
			$query = "INSERT INTO ".DB_PREFIX."rechtegruppen_rechte (rechtegrid, rechteid) VALUES ".implode(', ',$rgr);
			$_db->fuehreQueryAus($query);
			weiterleiten('/update.php?update='.$_GET['update']);
		}
	}

	# neue Einstellungen
	if(isset($updates[$_GET['update']]['neueeinstellungen'])){
		if(isset($updates[$_GET['update']]['neueeinstellungen']['global']) and count($updates[$_GET['update']]['neueeinstellungen']['global'])>0){
			$aktionen['neueeinstellungen_global'] = $updates[$_GET['update']]['neueeinstellungen']['global'];
			$aktionen['neueeinstellungen_global_angelegt'] = false;
			$einstellungen = parse_ini_file(PFAD_INCLUDE.'conf/einstellungen.ini', true);
			$t = $aktionen['neueeinstellungen_global'][0];
			if(isset($einstellungen[$t['gruppe']]) and isset($einstellungen[$t['gruppe']][$t['einstellung']])){
				$aktionen['neueeinstellungen_global_angelegt'] = true;
			}
			unset($einstellungen, $t);
			require_once(PFAD_INCLUDE.'conf/einstellungen-ini.php');			
			if(!$aktionen['neueeinstellungen_global_angelegt'] and isset($_POST['neueeinstellungen_global'])){
				require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
				$einst = new einstellungen('global');
				$einst->db = &$_db;
				$einst->aktualisiereGlobalIniDatei();
				weiterleiten('/update.php?update='.$_GET['update']);
			}
			$_tmpl->assign('_einstellungen_module', $_einstellungen_module);
			$_tmpl->assign('_einstellungen', $_einstellungen);
		}
		if(isset($updates[$_GET['update']]['neueeinstellungen']['user']) and count($updates[$_GET['update']]['neueeinstellungen']['user'])>0){
			$aktionen['neueeinstellungen_user'] = $updates[$_GET['update']]['neueeinstellungen']['user'];
			$aktionen['neueeinstellungen_user_angelegt'] = false;
			$einstellungen = parse_ini_file(PFAD_INIDATEIEN.'userconf_default.ini', true);
			$t = $aktionen['neueeinstellungen_user'][0];
			if(isset($einstellungen[$t['gruppe']]) and isset($einstellungen[$t['gruppe']][$t['einstellung']])){
				$aktionen['neueeinstellungen_user_angelegt'] = true;
			}
			unset($einstellungen, $t);
			require_once(PFAD_INCLUDE.'conf/user-ini.php');
			if(!$aktionen['neueeinstellungen_user_angelegt'] and isset($_POST['neueeinstellungen_user'])){
				require_once(PFAD_INCLUDE.'class/einstellungen.inc.php');
				$einst = new einstellungen('user','default');
				$einst->db = &$_db;
				$einst->aktualisiereUserinidateien();
				weiterleiten('/update.php?update='.$_GET['update']);
			}
			$_tmpl->assign('_usereinstellungen_module', $_usereinstellungen_module);
			$_tmpl->assign('_usereinstellungen', $_usereinstellungen);
		}
	}

	# Hinweise
	if(isset($updates[$_GET['update']]['hinweise']) and count($updates[$_GET['update']]['hinweise'])>0){
		$aktionen['hinweise'] = $updates[$_GET['update']]['hinweise'];
	}

	# Changelog
	require_once(PFAD_INCLUDE.'func/parsechangelog.inc.php');
	$changelog = parseChangelog('./CHANGELOG','v'.$_GET['update'],'v'.$_GET['update']);
	$aktionen['changelog'] = array_shift($changelog);

	# fertig
	$_tmpl->assign('aktionen', $aktionen);
	$_inh .= $_tmpl->fetch('admin/29.admin-update-einzelupdate.inc.html');
}
require_once('./__inc/_ende.inc.php');


############################################################################
### für Updates benötigte Funktionen #######################################
############################################################################

function aktualisiereDatei($datei, $daten=null){
	/*
	vorhandene Dateien:
	- config
	- #cronjob
	- #emails
	- htaccess
	*/
	global $_tmpl;
	
	$_tmpl->assign('daten',array());
	if(!is_null($daten)){
		$_tmpl->assign('daten', $daten);
	}

	switch($datei){
	case 'config':
		$confinhalt = $_tmpl->fetch('admin/29.admin-configincphp.inc.html');
		$fh = fopen(PFAD_INCLUDE.'conf/conf.inc.php','w');
		fwrite($fh, $confinhalt, strlen($confinhalt));
		fclose($fh);
		break;

	case 'htaccess':
		$grenze_umf = 2*1048576;
		$grenze_pms = 8*1048576;
		$speichern = array(
			'tkswim_dateiendung'  => defined('TKSWIM_DATEIENDUNG')?TKSWIM_DATEIENDUNG:'.php',
			'tkswim_kurzlinks'    => defined('TKSWIM_KURZLINKS')?TKSWIM_KURZLINKS:'false',
			'upload_max_filesize' => (TKSWIM_MAXDATEIGROESSE>$grenze_umf?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false),
			'post_max_size'       => (TKSWIM_MAXDATEIGROESSE>$grenze_pms?ceil(TKSWIM_MAXDATEIGROESSE/1048576).'M':false)
		);
		$_tmpl->assign('daten',$speichern);
		$htaccessinhalt = $_tmpl->fetch('admin/29.admin-htaccess.inc.html');
		$fh = fopen(PFAD_HTTP.'.htaccess','w');
		fwrite($fh, $htaccessinhalt, strlen($htaccessinhalt));
		fclose($fh);
		break;

	default:
		return false;
		break;
	}
	return true;
}

function leereTemplateCache(){
	# Template-Cache leeren (bei Änderungen in Templates werden die bei TKSWIM_DEBUG=false sonst nicht übernommen)
	if(!is_dir(PFAD_TEMPLATESC) or !is_writable(PFAD_TEMPLATESC)){
		return false;
	}
	$dh = opendir(PFAD_TEMPLATESC);
	while(false !== ($file = readdir($dh))){
		if($file == '.' or $file == '..'){
			continue;
		}
		unlink(PFAD_TEMPLATESC.'/'.$file);
	}
	closedir($dh);
	return true;
}
# EOF